############################################################################
#                                                                          #
#  Copyright (c) 2001, 2023 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
package KeysManager;no warnings;(my $__maxRotatedFiles=(0x02e9+ 5407-0x1802));
sub __getBackupFileName{(my $name=shift (@_));($name.=
"\x2e\x62\x61\x63\x6b\x75\x70");if ((not (Common::NXFile::fileExists ($name)))){
return ($name);}(my $number=(0x0361+ 5338-0x1839));while (($number<=
$__maxRotatedFiles)){if ((not (Common::NXFile::fileExists (($name.$number))))){
return (($name.$number));}($number+=(0x0b93+ 4665-0x1dcb));}($number=
(0x1dac+ 2292-0x269f));(my $oldestFile=$name);(my $oldestCTime=
Common::NXCore::NXFileCTime ($name));while (($number<=$__maxRotatedFiles)){(my $cTime
=Common::NXCore::NXFileCTime (($name.$number)));if (($oldestCTime>$cTime)){(
$oldestFile=($name.$number));($oldestCTime=$cTime);}($number+=
(0x039c+ 154-0x0435));}return ($oldestFile);}sub __backupKey{(my $file=shift (@_
));(my $backup=__getBackupFileName ($file));if (Common::NXFile::fileExists (
$file)){(my ($ret,$error)=Common::NXCore::copyFile ($file,$backup));if (($error 
ne (""))){Logger::warning ((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x62\x61\x63\x6b\x75\x70\x20\x66\x69\x6c\x65\x2e\x20"
.$error));return ((0x0cb8+ 5205-0x210c));}else{
Common::NXFile::setOwnerShipAndPermissionsReadOnlyForNX ($backup);}}return (
(0x0be9+ 3854-0x1af7));}sub __createRestore{(my $file=shift (@_));if ((not (
Common::NXFile::isExists ($file)))){Logger::debug (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x72\x65\x73\x74\x6f\x72\x65\x20\x66\x69\x6c\x65\x2e\x20"
.$file)."\x20\x64\x6f\x65\x73\x20\x6e\x6f\x74\x20\x65\x78\x69\x73\x74\x2e"));
return ((0x02a9+ 5147-0x16c4));}(my $restore=($file.
"\x2e\x72\x65\x73\x74\x6f\x72\x65"));if (Common::NXFile::isExists ($restore)){
Logger::debug (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x72\x65\x73\x74\x6f\x72\x65\x20\x66\x69\x6c\x65\x2e\x20"
.$restore)."\x20\x65\x78\x69\x73\x74\x73\x2e"));return ((0x03b8+ 7667-0x21ab));}
if (Common::NXFile::fileExists ($file)){(my ($ret,$error)=
Common::NXCore::copyFile ($file,$restore));if (($error ne (""))){Logger::warning
 ((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x72\x65\x73\x74\x6f\x72\x65\x20\x66\x69\x6c\x65\x2e\x20"
.$error));return ((0x133b+ 3267-0x1ffd));}else{
Common::NXFile::setPermissionReadWriteForOwnerReadOnlyForAll ($restore);}}return
 ((0x130d+ 2767-0x1ddc));}sub __createDefault{(my $file=shift (@_));(my $default
=shift (@_));if (Common::NXFile::fileExists ($default)){return (
(0x08ec+ 7008-0x244c));}if (Common::NXFile::fileExists ($file)){(my ($ret,$error
)=Common::NXCore::copyFile ($file,$default));if (($error ne (""))){
Logger::warning ((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x65\x66\x61\x75\x6c\x74\x20\x66\x69\x6c\x65\x2e\x20"
.$error));return ((0x03e5+ 2707-0x0e77));}else{
Common::NXFile::setPermissionReadWriteForOwnerReadOnlyForAll ($default);}}return
 ((0x133b+ 4653-0x2568));}sub backup{if ((__backupKey (
NXPaths::getNodePublicKeys ())==(0x0954+ 5732-0x1fb7))){return (
(0x175d+ 1067-0x1b87));}if ((__backupKey (
NXPaths::getUserDefaultRSAPublicKeyPath ())==(0x07d6+ 4376-0x18ed))){return (
(0x091f+ 3815-0x1805));}if ((__backupKey (NXPaths::getClientRSAPrivateKey ())==
(0x1331+ 2390-0x1c86))){return ((0x0e77+ 3626-0x1ca0));}if ((__backupKey (
NXPaths::getClientRSADefaultPrivateKey ())==(0x0903+ 2250-0x11cc))){return (
(0x117c+ 5105-0x256c));}if ((__backupKey (NXPaths::getClientDSADefaultPrivateKey
 ())==(0x04f7+ 5187-0x1939))){return ((0x0e1c+ 6000-0x258b));}if ((
__createRestore (NXPaths::getClientRSAPrivateKey ())==(0x155b+ 2490-0x1f14))){
return ((0x0254+ 8281-0x22ac));}return ((0x2373+  39-0x239a));}sub 
__generateRSAKeys{(my $public=NXPaths::getUserNewRSAPublicKey ());(my $private=
NXPaths::getUserNewRSAPrivateKey ());return (__generateKeys ($public,$private,
"\x72\x73\x61"));}sub __generateKeys{(my $publicKeyFileName=shift (@_));(my $privateKeyFileName
=shift (@_));(my $algorithm=shift (@_));(my (@command)=());(my (@options)=());(my $selinuxenabled
=NXTools::getUnixCommandPath (
"\x73\x65\x6c\x69\x6e\x75\x78\x65\x6e\x61\x62\x6c\x65\x64"));if (
Common::NXFile::isExists ($selinuxenabled)){(@command=$selinuxenabled);(my $runcon
=NXTools::getUnixCommandPath ("\x72\x75\x6e\x63\x6f\x6e"));(my ($cmd_err,
$cmd_out,$exit_value)=main::run_command ((\@command),(\@options)));if ((
$exit_value==(0x1546+ 1288-0x1a4e))){if (Common::NXFile::isExists ($runcon)){
push (@command,$runcon,"\x2d\x75","\x72\x6f\x6f\x74","\x2d\x72",
"\x73\x79\x73\x74\x65\x6d\x5f\x72","\x2d\x74","\x69\x6e\x69\x74\x72\x63\x5f\x74"
,"\x2d\x2d");}}else{Logger::debug2 (
"\x53\x65\x6c\x69\x6e\x75\x78\x20\x69\x73\x20\x64\x69\x73\x61\x62\x6c\x65\x64\x20\x69\x6e\x20\x74\x68\x69\x73\x20\x73\x79\x73\x74\x65\x6d"
);}}(@command=());push (@command,$GLOBAL::COMMAND_NXKEYGEN);push (@command,
"\x2d\x6b",$privateKeyFileName,"\x2d\x74",$algorithm,"\x2d\x70",
$publicKeyFileName);push (@options,"\x73\x65\x74\x20\x65\x6e\x76",(((
"\x4c\x44\x5f\x4c\x49\x42\x52\x41\x52\x59\x5f\x50\x41\x54\x48\x3d".
$GLOBAL::NODE_ROOT).$GLOBAL::DIRECTORY_SLASH)."\x6c\x69\x62"));push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x53\x59\x53\x54\x45\x4d\x3d".
$GLOBAL::NODE_ROOT));push (@options,"\x73\x65\x74\x20\x65\x6e\x76",(
"\x48\x4f\x4d\x45\x3d".NXPaths::getUserNXHomeDir ()));(my ($cmdErr,$cmdOut,
$exitValue)=main::nxRunCommand ((\@command),(\@options)));if (($exitValue!=
(0x0898+ 6808-0x2330))){Logger::error (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x6e\x65\x72\x61\x74\x65\x20".$algorithm).
"\x20\x6b\x65\x79\x20").$exitValue).
"\x2e\x20\x50\x6c\x65\x61\x73\x65\x20\x63\x68\x65\x63\x6b\x20\x74\x68\x65\x20\x27\x6e\x78\x73\x65\x72\x76\x65\x72\x2e\x6c\x6f\x67\x27\x20\x66\x69\x6c\x65\x20\x66\x6f\x72\x20\x70\x6f\x73\x73\x69\x62\x6c\x65\x20\x69\x73\x73\x75\x65\x73\x2e"
));}return ($exitValue);}sub __getKeysFromFile{(my $keyFile=shift (@_));if ((not
 (Common::NXFile::isExists ($keyFile)))){return (undef);}(my (@keyLists)=());(my $fileFH
=Common::NXCore::nxopen ($keyFile,$NXBits::O_RDONLY,(0x09ba+ 6221-0x2207)));if (
(not (defined ($fileFH)))){(my $error=libnxh::NXGetErrorName ());Logger::error (
((("\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20\x27".
$keyFile)."\x27\x3a\x20").$error));return (undef);}while (
Common::NXCore::nxreadLine ($fileFH,(\$_))){($_=~ s/\r//g );chomp ($_);push (
@keyLists,$_);}Common::NXCore::nxclose ($fileFH);return (@keyLists);}sub 
__addPrefix{(my $file=shift (@_));(my (@keys)=__getKeysFromFile ($file));if ((
not (defined (@keys)))){return ((0x0611+ 6176-0x1e30));}(my $fh=
Common::NXCore::nxopen ($file,$NXBits::O_WRONLY,(0x0c6d+ 441-0x0e26)));if ((not 
(defined ($fh)))){(my $error=libnxh::NXGetErrorName ());Logger::error (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20".$file).
"\x20\x74\x6f\x20\x77\x72\x69\x74\x65\x2e\x20").$error)."\x2e"));return (
(0x052b+ 1152-0x09aa));}foreach my $key (@keys){($key=__getKeyWithPrefix ($key))
;if ((Common::NXCore::nxwrite ($fh,$key)==(-(0x1592+ 2525-0x1f6e)))){(my $error=
libnxh::NXGetErrorName ());Logger::error (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20"
.$file)."\x3a\x20").$error)."\x2e"));Common::NXCore::nxclose ($fh);return (
(0x10a9+ 4310-0x217e));}}Common::NXCore::nxclose ($fh);return (
(0x0ae3+ 3357-0x1800));}sub __getKeyWithPrefix{(my $key=shift (@_));chomp ($key)
;chomp ($key);(my $keyWithPrefix.=
"\x6e\x6f\x2d\x70\x6f\x72\x74\x2d\x66\x6f\x72\x77\x61\x72\x64\x69\x6e\x67\x2c");
(my $path=NXPaths::getServerLaunchPath ());($keyWithPrefix.=((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x22".$path).
"\x20\x2d\x2d\x6c\x6f\x67\x69\x6e\x22\x20"));($keyWithPrefix.=$key);(
$keyWithPrefix.="\x0a");return ($keyWithPrefix);}sub generate{if (
isRSASuportedByServerConfig ()){if ((__generateRSAKeys ()>(0x0379+ 9057-0x26da))
){return ((0x07b2+ 7765-0x2606));}if ((__addPrefix (
NXPaths::getUserNewRSAPublicKey ())==(0x06b2+ 6098-0x1e83))){return (
(0x184c+ 1467-0x1e06));}}return ((0x0e10+ 4850-0x2102));}sub 
__changeRSAPublicKey{(my $file=NXPaths::getNodePublicKeys ());(my $oldKey=
NXPaths::getUserDefaultRSAPublicKeyPath ());if (Common::NXFile::isExists (
$oldKey)){if ((__removePublicKey ($file,$oldKey)==(0x01b0+ 2454-0x0b45))){return
 ((0x0fc1+ 3430-0x1d26));}}(my $newKey=NXPaths::getUserNewRSAPublicKey ());if ((
__addPublicKey ($file,$newKey)==(0x01d1+ 7859-0x2083))){return (
(0x0bac+ 3203-0x182e));}if ((__moveKey ($newKey,$oldKey)==(0x03a3+ 3810-0x1284))
){return ((0x0f2c+ 3046-0x1b11));}return ((0x097a+ 3339-0x1685));}sub 
__removePublicKey{(my $file=shift (@_));(my $oldKeyFile=shift (@_));(my (
@oldKeys)=__getKeysFromFile ($oldKeyFile));if ((not (defined (@oldKeys)))){
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x6f\x6c\x64\x20\x6b\x65\x79\x73\x20\x66\x6f\x72\x6d\x20\x66\x69\x6c\x65\x20"
.$oldKeyFile)."\x2e"));return ((0x18fc+ 3092-0x250f));}(my (@oldKeys)=
__getKeysFromFile ($oldKeyFile));foreach my $key (@oldKeys){__removePrefix ((
\$key));}foreach my $key (@oldKeys){if ((removeKeyFromFile ($key,$file,
"\x53\x53\x48")==(0x0b08+ 1285-0x100c))){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6d\x6f\x76\x65\x20\x6f\x6c\x64\x20\x6b\x65\x79\x20\x66\x6f\x72\x6d\x20\x66\x69\x6c\x65\x20"
.$file)."\x2e"));return ((0x0605+ 3418-0x135e));}}return ((0x12bc+ 1138-0x172e))
;}sub __removePrefix{(my $ref_key=shift (@_));if (($$ref_key=~ /(.*) (ssh-.*) (.*)/ )
){(my $type=$2);(my $value=$3);Logger::debug (((
"\x52\x65\x6d\x6f\x76\x65\x64\x20\x70\x72\x65\x66\x69\x78\x3a\x20".$1)."\x2e"));
($$ref_key=(($type."\x20").$value));}}sub __addPublicKey{(my $file=shift (@_));(my $newKeyFile
=shift (@_));(my (@newKeys)=__getKeysFromFile ($newKeyFile));if ((not (defined (
@newKeys)))){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x6e\x65\x77\x20\x6b\x65\x79\x73\x20\x66\x6f\x72\x6d\x20\x66\x69\x6c\x65\x20"
.$newKeyFile)."\x2e"));return ((0x21b8+ 796-0x24d3));}(my $fh=
Common::NXCore::nxopen ($file,(($NXBits::O_CREAT+$NXBits::O_WRONLY)+
$NXBits::O_APPEND),$NXBits::UserReadWrite));if ((not (defined ($fh)))){(my $error
=libnxh::NXGetErrorName ());Logger::error (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20".$file).
"\x20\x74\x6f\x20\x77\x72\x69\x74\x65\x2e\x20").$error)."\x2e"));return (
(0x0a38+ 3397-0x177c));}foreach my $key (@newKeys){if ((Common::NXCore::nxwrite 
($fh,($key."\x0a"))==(-(0x0a2c+   6-0x0a31)))){(my $error=libnxh::NXGetErrorName
 ());Logger::error (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20"
.$file)."\x3a\x20").$error)."\x2e"));Common::NXCore::nxclose ($fh);return (
(0x0609+ 5289-0x1ab1));}}Common::NXCore::nxclose ($fh);if ((
Common::NXFile::setOwnerShipAndPermissionsReadOnlyForNX ($file)==(-
(0x0aff+ 4375-0x1c15)))){return ((0x07f3+ 1683-0x0e85));}return (
(0x086d+ 876-0x0bd9));}sub __changeRSAPrivateKey{(my $newFile=
NXPaths::getUserNewRSAPrivateKey ());(my $clientFile=
NXPaths::getClientRSAPrivateKey ());if ((__moveKey ($newFile,$clientFile)==
(0x0bec+ 2312-0x14f3))){return ((0x2090+ 1300-0x25a3));}return (
(0x0ad0+ 4520-0x1c78));}sub __moveKey{(my $from=shift (@_));(my $to=shift (@_));
if (Common::NXFile::fileExists ($from)){if ((Common::NXCore::moveFile ($from,$to
)==(0x0f80+ 2938-0x1afa))){Logger::warning (
"\x43\x61\x6e\x6e\x6f\x74\x20\x6d\x6f\x76\x65\x20\x6b\x65\x79\x20\x66\x69\x6c\x65\x2e"
);return ((0x09b1+ 5572-0x1f74));}}else{Logger::warning (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6d\x6f\x76\x65\x20\x66\x69\x6c\x65\x20".$from).
"\x2e\x20\x46\x69\x6c\x65\x20\x64\x6f\x65\x73\x20\x6e\x6f\x74\x20\x65\x78\x69\x73\x74\x2e"
));return ((0x18c4+ 428-0x1a6f));}return ((0x1323+ 1762-0x1a05));}sub __copyKey{
(my $from=shift (@_));(my $to=shift (@_));if (Common::NXFile::fileExists ($from)
){(my ($ret,$error)=Common::NXCore::copyFile ($from,$to));if (($error ne (""))){
Logger::warning ((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x70\x79\x20\x73\x73\x68\x20\x70\x75\x62\x6c\x69\x63\x20\x6b\x65\x79\x20\x66\x69\x6c\x65\x2e\x20"
.$error));return ((0x0a7d+ 2812-0x1578));}else{if ((
Common::NXFile::setPermissionReadWriteForOwnerReadOnlyForAll ($to)==(-
(0x068a+ 4721-0x18fa)))){Logger::warning (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x66\x6f\x72\x20\x66\x69\x6c\x65\x20"
.$to)."\x2e"));return ((0x0a39+ 3531-0x1803));}}}else{Logger::warning (((
"\x53\x6f\x75\x72\x63\x65\x20\x6b\x65\x79\x20\x66\x69\x6c\x65\x20\x64\x6f\x65\x73\x20\x6e\x6f\x74\x20\x65\x78\x69\x73\x74\x20"
.$from)."\x2e"));return ((0x010b+ 398-0x0298));}return ((0x0d3b+ 5080-0x2113));}
sub change{if (isRSASuportedByServerConfig ()){if ((__changeRSAPublicKey ()==
(0x115a+ 1393-0x16ca))){return ((0x08fd+ 6942-0x241a));}if ((
__changeRSAPrivateKey ()==(0x0041+ 721-0x0311))){return ((0x149a+ 3150-0x20e7));
}}return ((0x0353+ 5187-0x1796));}sub __restoreRSAPublicKey{(my $file=
NXPaths::getNodePublicKeys ());(my $oldKey=
NXPaths::getUserDefaultRSAPublicKeyPath ());if (Common::NXFile::isExists (
$oldKey)){if ((__removePublicKey ($file,$oldKey)==(0x2477+ 377-0x25ef))){return 
((0x031d+ 4765-0x15b9));}}(my $newKey=NXPaths::getRestoreRSAPublicKey ());if ((
__addPublicKey ($file,$newKey)==(0x04bb+ 3465-0x1243))){return (
(0x1161+ 971-0x152b));}if ((__copyKey ($newKey,$oldKey)==(0x101f+ 1906-0x1790)))
{return ((0x130b+ 3297-0x1feb));}return ((0x19e8+ 190-0x1aa6));}sub 
__restoreRSAPrivateKey{(my $restoreKey=NXPaths::getClientRSARestorePrivateKey ()
);(my $clientKey=NXPaths::getClientRSAPrivateKey ());if ((__copyKey ($restoreKey
,$clientKey)==(0x12ab+ 4728-0x2522))){return ((0x047c+ 1503-0x0a5a));}return (
(0x037c+ 4738-0x15fe));}sub restore{if (isRSASuportedByServerConfig ()){if ((
__restoreRSAPublicKey ()==(0x0363+ 4889-0x167b))){return ((0x182c+ 1215-0x1cea))
;}if ((__restoreRSAPrivateKey ()==(0x04bb+ 5977-0x1c13))){return (
(0x05e9+ 3385-0x1321));}}return ((0x0a4c+ 1493-0x1021));}sub __isKeyInLine{(my $key
=shift (@_));(my $line=shift (@_));(my $protocol=shift (@_));($key=~ s/\r//g );(
$key=~ s/\n//g );chomp ($key);(my ($keyType,$keyValue)=split ( / / ,$key,
(0x0b96+ 752-0x0e83)));($line=~ s/\r//g );($line=~ s/\n//g );chomp ($line);(my (
@lineFields)=split ( / / ,$line,(0x1a72+ 2321-0x2383)));if (($protocol eq 
"\x53\x53\x48")){if ((($keyType eq $lineFields[(0x0635+ 6978-0x2175)])and (
$keyValue eq $lineFields[(0x09f0+ 2067-0x1200)]))){Logger::debug (((
"\x4b\x65\x79\x20\x27".$key).
"\x27\x20\x6b\x65\x79\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x6c\x69\x6e\x65\x2e"
));return ((0x1a20+ 107-0x1a8a));}if ((($keyType eq $lineFields[
(0x1ed0+ 976-0x229f)])and ($keyValue eq $lineFields[(0x0856+ 890-0x0bce)]))){
Logger::debug ((("\x4b\x65\x79\x20\x27".$key).
"\x27\x20\x6b\x65\x79\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x6c\x69\x6e\x65\x2e"
));return ((0x04a3+ 3202-0x1124));}}else{if ((($keyType eq $lineFields[
(0x0062+ 9115-0x23fd)])and ($keyValue eq $lineFields[(0x11a9+ 2959-0x1d37)]))){
Logger::debug ((("\x4b\x65\x79\x20\x27".$key).
"\x27\x20\x6b\x65\x79\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x6c\x69\x6e\x65\x2e"
));return ((0x06e6+ 6297-0x1f7e));}}return ((0x0896+ 6653-0x2293));}sub 
__isAnyKeyInLine{(my $line=shift (@_));(my $protocol=shift (@_));($line=~ s/\r//g )
;($line=~ s/\n//g );chomp ($line);(my (@lineFields)=split ( / / ,$line,
(0x1c23+ 1539-0x2226)));if (($protocol eq "\x53\x53\x48")){if ((($lineFields[
(0x02ba+ 5713-0x1909)]ne (""))and ($lineFields[(0x1153+ 3526-0x1f16)]ne ("")))){
Logger::debug (
"\x4b\x65\x79\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x6c\x69\x6e\x65\x2e");
return ((0x0346+ 8787-0x2598));}if ((($lineFields[(0x152f+ 3445-0x22a3)]ne (""))
and ($lineFields[(0x1b50+ 1571-0x2171)]ne ("")))){Logger::debug (
"\x4b\x65\x79\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x6c\x69\x6e\x65\x2e");
return ((0x2656+ 146-0x26e7));}}else{if ((($lineFields[(0x00fb+ 7830-0x1f91)]ne 
(""))and ($lineFields[(0x0ecb+ 4997-0x224f)]ne ("")))){Logger::debug (
"\x4b\x65\x79\x20\x6b\x65\x79\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x6c\x69\x6e\x65\x2e"
);return ((0x0b47+ 1774-0x1234));}}return ((0x189a+ 3123-0x24cd));}sub 
removeKeyFromFile{(my $keyToRemove=shift (@_));(my $filePath=shift (@_));(my $protocol
=shift (@_));(my $tempFilePath=(($filePath."\x2e\x74\x6d\x70\x2e").$ $));
 (my $fileFH
=Common::NXCore::nxopen ($filePath,$NXBits::O_RDONLY,(0x0e6a+ 1509-0x144f)));if 
((not (defined ($fileFH)))){(my $error=libnxh::NXGetErrorName ());Logger::error 
(((("\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20\x27".
$filePath)."\x27\x3a\x20").$error));return ((0x0e2f+ 331-0x0f79));}(my $tempFileFH
=Common::NXCore::nxopen ($tempFilePath,(($NXBits::O_CREAT+$NXBits::O_WRONLY)+
$NXBits::O_APPEND),$NXBits::UserReadWrite));if ((not (defined ($tempFileFH)))){(my $error
=libnxh::NXGetErrorName ());Logger::error ((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x74\x65\x6d\x70\x6f\x72\x61\x72\x79\x20\x66\x69\x6c\x65\x20\x27"
.$tempFilePath)."\x27\x3a\x20").$error));return ((0x0603+ 2561-0x1003));}while (
Common::NXCore::nxreadLine ($fileFH,(\$_))){(my $line=$_);if (__isKeyInLine (
$keyToRemove,$line,$protocol)){Logger::debug (((
"\x52\x65\x6d\x6f\x76\x69\x6e\x67\x20\x6b\x65\x79\x20\x27".$line)."\x27\x2e"));}
else{Common::NXCore::nxwrite ($tempFileFH,$line);}}Common::NXCore::nxclose (
$tempFileFH);Common::NXCore::nxclose ($fileFH);if ((Common::NXFile::renameFile (
$tempFilePath,$filePath)==(0x170c+ 2507-0x20d7))){return ((0x18e9+  56-0x1920));
}if ((Common::NXFile::setOwnerShipAndPermissionsForNX ($filePath)==(-
(0x0786+ 2827-0x1290)))){return ((0x16a5+ 2192-0x1f34));}return (
(0x00e9+ 5539-0x168c));}sub isKeyInFile{(my $key=shift (@_));(my $keyFile=shift 
(@_));(my $protocol=shift (@_));(my (@listSupportedKeys)=__getKeysFromFile (
$keyFile));foreach my $line (@listSupportedKeys){if (__isKeyInLine ($key,$line,
$protocol)){Logger::debug (
"\x4b\x65\x79\x20\x69\x73\x20\x69\x6e\x20\x74\x68\x65\x20\x66\x69\x6c\x65\x2e");
return ((0x0a3f+ 4031-0x19fd));}}Logger::debug (
"\x4b\x65\x79\x20\x69\x73\x20\x75\x6e\x69\x71\x75\x65\x2e");return (
(0x0c86+ 2289-0x1577));}sub restorePrivateKey{(my $privateKey=
NXPaths::getClientPrivateKey ());(my $defaultPrivateKey=
NXPaths::getClientDefaultPrivateKey ());(my $restore=($privateKey.
"\x2e\x72\x65\x73\x74\x6f\x72\x65"));if (Common::NXFile::fileExists ($restore)){
copyKeyFile ($restore,$privateKey);copyKeyFile ($restore,$defaultPrivateKey);}}
sub isNotExistNodePublicKey{if (((not (Common::NXFile::isExists (
NXPaths::getNodePublicKeys ())))and (not (Common::NXFile::isExists (
NXPaths::getNXAuthorizedKeysPath ("\x6e\x78")))))){return ((0x0045+ 4468-0x11b8)
);}if (Common::NXFile::isExists (NXPaths::getNXAuthorizedKeysPath ("\x6e\x78")))
{(my (@listSupportedKeys)=__getKeysFromFile (NXPaths::getNXAuthorizedKeysPath (
"\x6e\x78")));foreach my $line (@listSupportedKeys){if (__isAnyKeyInLine ($line,
"\x4e\x58")){Logger::debug (
"\x46\x6f\x75\x6e\x64\x20\x4e\x58\x20\x6b\x65\x79\x2e");return (
(0x1b29+ 656-0x1db9));}}}if (Common::NXFile::isExists (
NXPaths::getNodePublicKeys ())){(my (@listSupportedKeys)=__getKeysFromFile (
NXPaths::getNodePublicKeys ()));foreach my $line (@listSupportedKeys){if (
__isAnyKeyInLine ($line,"\x53\x53\x48")){Logger::debug (
"\x46\x6f\x75\x6e\x64\x20\x53\x53\x48\x20\x6b\x65\x79\x2e");return (
(0x0033+ 6014-0x17b1));}}}return ((0x0a39+ 2516-0x140c));}sub 
getSupportedSSHDKeyExchangeAlgorithm{if ((
$GLOBAL::SupportedSSHDKeyExchangeAlgorithm=~ /DSA|RSA|all|DSA,RSA|RSA,DSA/ )){
return ($GLOBAL::SupportedSSHDKeyExchangeAlgorithm);}else{Logger::warning (((
"\x57\x72\x6f\x6e\x67\x20\x76\x61\x6c\x75\x65\x20\x66\x6f\x72\x20\x6b\x65\x79\x3a\x20\x53\x75\x70\x70\x6f\x72\x74\x65\x64\x53\x53\x48\x44\x4b\x65\x79\x45\x78\x63\x68\x61\x6e\x67\x65\x41\x6c\x67\x6f\x72\x69\x74\x68\x6d\x3a\x20"
.$GLOBAL::SupportedSSHDKeyExchangeAlgorithm).
"\x20\x75\x73\x65\x20\x61\x6c\x6c\x2e"));return ("\x61\x6c\x6c");}}sub 
isDSASuportedByServerConfig{(my $supportedKeyList=
getSupportedSSHDKeyExchangeAlgorithm ());if (($supportedKeyList=~ /DSA/ )){
return ((0x16d5+ 3929-0x262d));}if (($supportedKeyList eq "\x61\x6c\x6c")){
return ((0x0b2f+   6-0x0b34));}return ((0x0d1d+ 2058-0x1527));}sub 
isRSASuportedByServerConfig{(my $supportedKeyList=
getSupportedSSHDKeyExchangeAlgorithm ());if (($supportedKeyList=~ /RSA/ )){
return ((0x1552+  63-0x1590));}if (($supportedKeyList eq "\x61\x6c\x6c")){return
 ((0x0d81+ 3859-0x1c93));}return ((0x0741+ 3190-0x13b7));}sub add{(my $ref_parameters
=shift (@_));($$ref_parameters{"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"}=uc (
$$ref_parameters{"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"}));if (($$ref_parameters{
"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"}eq (""))){($$ref_parameters{
"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"}="\x4e\x58");}unless (__getKey (
$ref_parameters)){return ((0x0f5f+ 1578-0x1589));}unless (prepareKey (
$ref_parameters)){return ((0x0d11+ 1720-0x13c9));}unless (setKey (
$ref_parameters)){return ((0x07f4+ 4173-0x1841));}NXMsg::send_response (
"\x69\x43\x4d\x44\x50\x75\x62\x6c\x69\x63\x4b\x65\x79\x41\x64\x64\x65\x64\x4f\x6b"
,"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",$$ref_parameters{
"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"},$$ref_parameters{
"\x61\x75\x74\x68\x46\x69\x6c\x65"});return ((0x06e8+ 4435-0x183a));}sub 
__getKey{(my $ref_parameters=shift (@_));if (($$ref_parameters{
"\x6b\x65\x79\x46\x69\x6c\x65"}ne (""))){unless (__getKeyFromFile (
$ref_parameters)){return ((0x01dd+ 1215-0x069c));}return ((0x21b5+ 1224-0x267c))
;}unless (__getKeyFromSTDIN ($ref_parameters)){return ((0x07f8+ 1340-0x0d34));}
return ((0x1396+ 2838-0x1eab));}sub __getKeyFromFile{(my $ref_parameters=shift (
@_));unless (Common::NXFile::isExists ($$ref_parameters{
"\x6b\x65\x79\x46\x69\x6c\x65"})){NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x4e\x6f\x74\x45\x78\x69\x73\x74"
,"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",$$ref_parameters{
"\x6b\x65\x79\x46\x69\x6c\x65"});return ((0x15af+ 3689-0x2418));}(my $INFILE=
Common::NXCore::nxopen ($$ref_parameters{"\x6b\x65\x79\x46\x69\x6c\x65"},
$NXBits::O_RDONLY));unless (defined ($INFILE)){NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x43\x61\x6e\x6e\x6f\x74\x52\x65\x61\x64"
,"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",$$ref_parameters{
"\x6b\x65\x79\x46\x69\x6c\x65"});return ((0x16d0+ 692-0x1984));}if ((
Common::NXCore::nxread ($INFILE,(\$$ref_parameters{"\x6b\x65\x79"}))==
(0x1f11+ 536-0x2129))){NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x45\x6d\x70\x74\x79\x46\x69\x6c\x65"
,"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",$$ref_parameters{
"\x6b\x65\x79\x46\x69\x6c\x65"});Common::NXCore::nxclose ($INFILE);return (
(0x05e8+ 3464-0x1370));}Logger::debug ((((("\x4b\x65\x79\x20\x27".
$$ref_parameters{"\x6b\x65\x79"}).
"\x27\x20\x72\x65\x61\x64\x20\x66\x72\x6f\x6d\x20\x66\x69\x6c\x65\x20\x27").
$$ref_parameters{"\x6b\x65\x79\x46\x69\x6c\x65"})."\x27\x2e"));
Common::NXCore::nxclose ($INFILE);return ((0x16c6+ 444-0x1881));}sub 
__getKeyFromSTDIN{(my $ref_parameters=shift (@_));(my $message=
"\x4e\x58\x3e\x20\x39\x32\x33\x20\x50\x6c\x65\x61\x73\x65\x20\x65\x6e\x74\x65\x72\x20\x74\x68\x65\x20\x73\x73\x68\x2d\x64\x73\x73\x20\x6b\x65\x79\x3a"
);(my $bytes=main::nxwrite (main::nxgetSTDOUT (),$message));unless (($bytes>
(0x2425+ 176-0x24d5))){Logger::error (
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x6b\x65\x79\x20\x72\x65\x71\x75\x65\x73\x74\x20\x6f\x6e\x20\x53\x54\x44\x4f\x55\x54\x2e"
);return ((0x154a+ 3414-0x22a0));}(($$ref_parameters{"\x6b\x65\x79"},
$$ref_parameters{"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"},$$ref_parameters{
"\x75\x75\x69\x64"})=__retrieveKey ());if (($$ref_parameters{"\x6b\x65\x79"}eq 
(""))){Logger::error (
"\x50\x75\x62\x6c\x69\x63\x20\x6b\x65\x79\x20\x6e\x6f\x74\x20\x70\x72\x6f\x76\x69\x64\x65\x64\x2e"
);return ((0x03f2+ 4861-0x16ef));}($$ref_parameters{"\x6b\x65\x79"}.="\x0a");
return ((0x0e85+ 290-0x0fa6));}sub prepareKey{(my $ref_parameters=shift (@_));(my $proto
=$$ref_parameters{"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"});if (($proto eq "\x4e\x58"
)){(my $authFile=NXPaths::getNXAuthorizedKeysPath ("\x6e\x78"));(my $authDir=
Common::NXFile::dirname ($authFile));Logger::debug (((
"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x41\x75\x74\x68\x6f\x72\x69\x7a\x65\x64\x20\x6b\x65\x79\x73\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20\x27"
.$authDir)."\x27\x2e"));if ((not (Common::NXFile::directoryExists ($authDir)))){my (
$error);unless (Common::NXPaths::createAccessibleForNXDirectory ((\$error),
$authDir)){NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x44\x69\x72"
,"\x4e\x58\x53\x68\x65\x6c\x6c",$proto,$authDir);return ((0x185a+ 1027-0x1c5d));
}}($$ref_parameters{"\x61\x75\x74\x68\x46\x69\x6c\x65"}=$authFile);Logger::debug
 (((
"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x41\x75\x74\x68\x6f\x72\x69\x7a\x65\x64\x20\x6b\x65\x79\x73\x20\x66\x69\x6c\x65\x20\x27"
.$$ref_parameters{"\x61\x75\x74\x68\x46\x69\x6c\x65"})."\x27\x2e"));}elsif ((
$proto eq "\x53\x53\x48")){($$ref_parameters{"\x61\x75\x74\x68\x46\x69\x6c\x65"}
=NXPaths::getNodePublicKeys ());if (isKeyInFile ($$ref_parameters{"\x6b\x65\x79"
},$$ref_parameters{"\x61\x75\x74\x68\x46\x69\x6c\x65"},$proto)){
removeKeyFromFile ($$ref_parameters{"\x6b\x65\x79"},$$ref_parameters{
"\x61\x75\x74\x68\x46\x69\x6c\x65"},$proto);}}else{NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x55\x6e\x6b\x6e\x6f\x77\x6e\x50\x72\x6f\x74\x6f"
,"\x4e\x58\x53\x68\x65\x6c\x6c");return ((0x01d8+ 5609-0x17c1));}if (
Common::NXFile::isExists ($$ref_parameters{"\x61\x75\x74\x68\x46\x69\x6c\x65"}))
{if ((Common::NXFile::setPermissionsReadWriteForNX ($$ref_parameters{
"\x61\x75\x74\x68\x46\x69\x6c\x65"})==(-(0x0d2f+ 354-0x0e90)))){NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x43\x61\x6e\x6e\x6f\x74\x53\x65\x74\x50\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73"
,"\x4e\x58\x53\x68\x65\x6c\x6c",$proto,$$ref_parameters{
"\x61\x75\x74\x68\x46\x69\x6c\x65"});return ((0x081d+ 4014-0x17cb));}}return (
(0x0980+ 6434-0x22a1));}sub setKey{(my $ref_parameters=shift (@_));(my $filepath
=$$ref_parameters{"\x61\x75\x74\x68\x46\x69\x6c\x65"});(my $mode=((
$NXBits::O_WRONLY+$NXBits::O_CREAT)+$NXBits::O_APPEND));(my $permissions=
$NXBits::UserReadWrite);(my $OUTFILE=Common::NXCore::nxopen ($filepath,$mode,
$permissions));unless (defined ($OUTFILE)){(my $errorString=
libnxh::NXGetErrorName ());NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x43\x61\x6e\x6e\x6f\x74\x4f\x70\x65\x6e\x54\x6f\x57\x72\x69\x74\x65"
,"\x4e\x58\x53\x68\x65\x6c\x6c",$$ref_parameters{
"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"},$filepath);return ((0x0cb5+ 5956-0x23f9));}(my $keyToSave
=$$ref_parameters{"\x6b\x65\x79"});if (($$ref_parameters{
"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"}eq "\x53\x53\x48")){($keyToSave=
NXNodeExec::addPrefixForSSHKey ($$ref_parameters{"\x6b\x65\x79"}));}if ((
Common::NXCore::nxwrite ($OUTFILE,$keyToSave)==(-(0x12d4+ 2823-0x1dda)))){
NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x43\x61\x6e\x6e\x6f\x74\x57\x72\x69\x74\x65"
,"\x4e\x58\x53\x68\x65\x6c\x6c",$$ref_parameters{
"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"},$filepath);Common::NXCore::nxclose ($OUTFILE
);return ((0x0627+ 6568-0x1fcf));}Common::NXCore::nxclose ($OUTFILE);if ((
Common::NXFile::setOwnerShipAndPermissionsForNX ($filepath)==(-
(0x0e23+ 2173-0x169f)))){NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x43\x61\x6e\x6e\x6f\x74\x53\x65\x74\x50\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73"
,"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",$$ref_parameters{
"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"},$filepath);return ((0x0323+ 5427-0x1856));}
if (($$ref_parameters{"\x75\x75\x69\x64"}ne (""))){NXNodes::setAccessKey (
$$ref_parameters{"\x75\x75\x69\x64"},$$ref_parameters{"\x6b\x65\x79"});}return (
(0x0051+ 7923-0x1f43));}sub __retrieveKey{(my $selector=
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x53\x65\x6c\x65\x63\x74\x6f\x72"->new)
;(my $signalFd=$$NXBegin::parser{"\x53\x69\x67\x6e\x61\x6c"});($$NXBegin::parser
{"\x73\x69\x67\x62\x61\x63\x6b"}{"\x49\x4e\x54"}=sub{Common::NXCore::nxexit ();}
);$selector->add ($signalFd);$selector->add (main::nxgetSTDIN ());(my $key=(""))
;(my $protocol=(""));(my $finish=(0x1136+ 3951-0x20a5));while (($finish==
(0x10e2+ 961-0x14a3))){(my (@ready)=$selector->can_read ((0x1458+ 7943-0x1fd7)))
;if ((scalar (@ready)==(0x1476+ 1511-0x1a5d))){Logger::debug (
"\x4e\x6f\x74\x68\x69\x6e\x67\x20\x74\x6f\x20\x72\x65\x61\x64\x2e");($finish=
(0x0104+ 6264-0x197b));}foreach my $fh (@ready){Logger::debug (((
"\x43\x68\x65\x63\x6b\x69\x6e\x67\x20\x46\x44\x23".$fh)."\x2e"));if (($fh==
main::nxgetSTDIN ())){my ($read_buf);(my $bytes_read=main::nxread ($fh,(
\$read_buf),(0x2247+ 4445-0x23a4)));Logger::debug (((
"\x52\x65\x61\x64\x20\x66\x72\x6f\x6d\x20\x53\x54\x44\x49\x4e\x20\x27".$read_buf
)."\x27\x2e"));if (($read_buf=~ /NX> params=(.*) / )){(my (%hashParameters)=
NXShell::urlParameter2Hash ($1));($key=$hashParameters{"\x6b\x65\x79"});(
$protocol=$hashParameters{"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"});($uuid=
$hashParameters{"\x75\x75\x69\x64"});$selector->remove (main::nxgetSTDIN ());
$selector->remove ($signalFd);($finish=(0x133c+ 1402-0x18b5));}elsif ((
$bytes_read==(0x0696+ 1469-0x0c53))){$selector->remove (main::nxgetSTDIN ());
$selector->remove ($signalFd);($finish=(0x1a12+ 729-0x1cea));}}}}return ($key,
$protocol,$uuid);}NXMsg::register_response (
"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x41\x64\x64\x69\x6e\x67\x4b\x65\x79",(0x0685+ 1070-0x0a19));
NXMsg::register_response ("\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x50\x75\x62\x6c\x69\x63\x4b\x65\x79\x41\x64\x64\x65\x64\x4f\x6b"
,(0x0441+ 8456-0x24ae));NXMsg::register_error (
"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x4e\x6f\x74\x45\x78\x69\x73\x74"
,(0x1732+ 2796-0x1fda));NXMsg::register_error (
"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x43\x61\x6e\x6e\x6f\x74\x52\x65\x61\x64"
,(0x0815+ 2364-0x0f0d));NXMsg::register_error (
"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x45\x6d\x70\x74\x79\x46\x69\x6c\x65"
,(0x0654+ 5133-0x181d));return ((0x0cb7+ 205-0x0d83));
