############################################################################
#                                                                          #
#  Copyright (c) 2001, 2023 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
sub NXRedis::BEGIN{package NXRedis;no warnings;require NXMsg;do{
"\x4e\x58\x4d\x73\x67"->import};}package NXRedis;no warnings;$selector;
$readRedis;$writeRedis;$daemonRedis;$clientRedis;($retry=(0x01b2+ 7844-0x2056));
($connected=(0x1497+ 4407-0x25ce));($serverInit=(0x11e7+ 4810-0x24b1));(
$multiCommand=(0x084f+ 7251-0x24a2));($resendSuccess=(0x01f9+ 1997-0x09c6));(
$waitingConnect=(0x0af3+ 190-0x0bb1));($lockFileHandle=(-(0x0e93+ 1285-0x1397)))
;($redisServerPid=(-(0x0301+ 4624-0x1510)));($waitingForAcquireTimeout=
(0x10e5+ 2554-0x1a2b));($waitingForReleaseCounter=(0x0977+ 5092-0x1d5b));(
$waitingForNewDaemonCounter=(0x0b1b+ 2029-0x1308));($waitingForReleaseSendKill=
(0x0213+ 3281-0x0ec6));($waitingForRedisDaemonReply=(0x0e35+ 2627-0x1875));(
$waitingForNonDaemonServerReleaseTimeout=(0x0461+ 2033-0x0bee));(
$timeoutForNewDaemonWaiting=(0x0e53+ 4035-0x1d26));($waitingForNewDaemonTick=0.5
);($failCounter=(0x0879+ 110-0x08e7));($finalizeProcessStarted=
(0x0989+ 6034-0x211b));($doNotCloseRedisThreadsWhenFreePerl=
(0x03b1+ 1434-0x094b));($waitForResponseTimeout=(0x017f+ 3737-0x100e));(
$waitIntervalTime=0.1);($maxWaitTimeout=(0x0832+ 5262-0x1b94));
@waitingCommandList;@responses;@sendCommandList;($descriptorLimit=
(0x101a+ 847-0x0369));($errorDuringLastCommand=(0x0d00+ 1936-0x1490));sub 
initRedisServer{if (($serverInit==(0x0f9c+ 2965-0x1b31))){(my $cookie=
NXServerDaemon::getCookie ());setNxDirInNXHomeDirOwner ();if (
main::nxPipeCreateBi ((\$daemonRedis),(\$clientRedis))){Logger::debug (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x72\x65\x61\x74\x65\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x5b"
.$daemonRedis)."\x2f").$clientRedis)."\x5d\x2e"));}else{Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x70\x61\x69\x72\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
);return;}(my $returnValue=libnxhs::NXRedisServerCreate ($daemonRedis,$cookie,
NXPaths::getRedisDatabaseDirectory (),NXPaths::getNXErrorFile ()));if ((
$returnValue==(0x07ef+ 6011-0x1f69))){($serverInit=(0x1b83+ 2458-0x251c));
Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x72\x76\x65\x72\x20\x73\x74\x61\x72\x74\x69\x6e\x67\x2e"
);Common::NXCore::doNotCloseSocketAtFinish ($daemonRedis);}else{Logger::error ((
(
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x72\x76\x65\x72\x20\x69\x6e\x69\x74\x69\x61\x6c\x69\x7a\x65\x20\x65\x72\x72\x6f\x72\x20\x77\x69\x74\x68\x20\x72\x65\x74\x75\x72\x6e\x20\x76\x61\x6c\x75\x65\x3a\x20"
.$returnValue)."\x2e"));(my $error=libnxh::NXGetErrorName ());(my $errorstring=
libnxh::NXGetErrorString ());Logger::error (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20".
$error)."\x3a\x20").$errorstring)."\x2e"));main::nxexit ();}}elsif ((not (
checkRedisFlock ()))){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x44\x61\x74\x61\x62\x61\x73\x65\x20\x73\x65\x72\x76\x65\x72\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x6f\x6e\x20\x6f\x74\x68\x65\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
);removeRedisServerLockFileHandle ();}else{Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x44\x61\x74\x61\x62\x61\x73\x65\x20\x73\x65\x72\x76\x65\x72\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x6f\x6e\x20\x74\x68\x69\x73\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
);}}sub auth{my ($cookie);if (($serverInit==(0x111d+ 5606-0x2703))){($cookie=
NXClientSystemDaemons::getCookieForRedisAuthentication ());}else{($cookie=
NXServerDaemon::getCookie ());}if (($cookie ne (""))){sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x61\x75\x74\x68\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d"
.$cookie)."\x0a"));(my $returnValue=get ());if (($returnValue ne "\x4f\x4b")){
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x41\x75\x74\x68\x65\x6e\x74\x69\x63\x61\x74\x65\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x72\x65\x74\x75\x72\x6e\x20\x76\x61\x6c\x75\x65\x3a\x20"
.$returnValue)."\x2e"));forceCloseRedisClient ();checkFailCounter ();return (
(0x01dd+ 546-0x03fe));}else{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x73\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x61\x75\x74\x68\x65\x6e\x74\x69\x63\x61\x74\x65\x64\x2e"
);($failCounter=(0x0970+ 7287-0x25e7));return ((0x00a1+ 679-0x0348));}}else{
forceCloseRedisClient ();checkFailCounter ();Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x41\x75\x74\x68\x65\x6e\x74\x69\x63\x61\x74\x69\x6f\x6e\x20\x63\x6f\x6f\x6b\x69\x65\x20\x69\x73\x20\x65\x6d\x70\x74\x79\x2c\x20\x63\x61\x6e\x6e\x6f\x74\x20\x61\x75\x74\x68\x65\x6e\x74\x69\x63\x61\x74\x65\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);return ((0x04a6+ 7997-0x23e2));}}sub initRedisClient{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x49\x6e\x69\x74\x69\x61\x6c\x69\x7a\x65\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x2e"
);if ((($readRedis eq (""))or ($writeRedis eq ("")))){if (
libnxhs::NXRedisClientRunning ()){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x63\x72\x65\x61\x74\x65\x64\x2e"
);Logger::debug (
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x53\x75\x62\x73\x79\x73\x74\x65\x6d\x47\x65\x74\x52\x65\x64\x69\x73\x46\x64\x28\x29"
);(my $FD=libnxhs::NXSubsystemGetRedisFd ());Logger::debug2 (((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x53\x75\x62\x73\x79\x73\x74\x65\x6d\x47\x65\x74\x52\x65\x64\x69\x73\x46\x64\x28\x29\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$FD)."\x27\x2e"));if (($FD>=(0x074c+ 4397-0x1879))){($connected=
(0x0d2b+ 4223-0x1da9));($readRedis=$FD);Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x64\x69\x73\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x69\x6e\x68\x65\x72\x69\x74\x65\x64\x20\x46\x44\x23"
.$FD)."\x2e"));($selector=
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x53\x65\x6c\x65\x63\x74\x6f\x72"->new)
;$selector->add ($readRedis);$selector->add ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});}else{Logger::warning (
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x52\x65\x64\x69\x73\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x2e"
);}if (checkIfSubscriptionShouldBeStarted ()){main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e");
NXRedisSubscription::createSubscriptionClient ();}return;}if ((not (
main::nxPipeCreateBi ((\$readRedis),(\$writeRedis))))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x70\x61\x69\x72\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x2e"
);return ((0x0c2b+ 1133-0x1098));}(my $homeDir=NXPaths::getUserNXHomeDir ());
libnxh::NXTransSetEnvironment ("\x48\x4f\x4d\x45",$homeDir);Logger::debug (((((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x72\x65\x61\x74\x65\x28"
.$writeRedis)."\x2c\x20").$writeRedis)."\x29"));(my $rettmp=
libnxhs::NXRedisCreate ($writeRedis,$writeRedis));Logger::debug (((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x72\x65\x61\x74\x65\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$rettmp)."\x27\x2e"));Common::NXCore::doNotCloseSocketAtFinish ($writeRedis);}(
$selector=
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x53\x65\x6c\x65\x63\x74\x6f\x72"->new)
;$selector->add ($readRedis);$selector->add ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});if (($serverInit==(0x0f2d+ 3545-0x1d06))){if ((
NXClientSystemDaemons::openConnection ((0x13f7+ 516-0x15fa))!=
(0x0e2b+ 4095-0x1e29))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
);return ((0x04cb+ 3293-0x11a8));}if (main::nxPipeCreateBi ((\$daemonRedis),(
\$clientRedis))){Logger::debug (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x72\x65\x61\x74\x65\x64\x20\x73\x65\x63\x6f\x6e\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x5b"
.$daemonRedis)."\x2f").$clientRedis)."\x5d\x2e"));}else{Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x73\x65\x63\x6f\x6e\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x70\x61\x69\x72\x20\x66\x6f\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x2e"
);return ((0x11ef+ 3525-0x1fb4));}(my $socketCookie=main::get_unique_id ());(my $tmpDir
=NXPaths::getTmpDir ());(my $socketPath=(($tmpDir.$GLOBAL::DIRECTORY_SLASH).
main::get_unique_id ()));(my $message=(("\x4e\x58\x3e\x20".
$GLOBAL::MSG_REDIS_YIELD)."\x20\x52\x65\x64\x69\x73\x20\x79\x69\x65\x6c\x64"));(
$message.=("\x20\x70\x69\x64\x3d".$ $));
 ($message.=(
"\x20\x73\x6f\x63\x6b\x65\x74\x50\x61\x74\x68\x45\x6e\x63\x6f\x64\x65\x64\x3d".
main::urlencode ($socketPath)));($message.=(
"\x20\x73\x6f\x63\x6b\x65\x74\x43\x6f\x6f\x6b\x69\x65\x3d".$socketCookie));(
$message.=("\x20\x66\x64\x3d".$daemonRedis));($message.="\x20\x0a");if ((
NXClientSystemDaemons::sendMessage ($message)!=(0x0fd9+ 5448-0x2520))){
Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
);return ((0x0783+ 4388-0x18a7));}Server::saveTimestamp (
"\x72\x65\x64\x69\x73\x43\x6c\x69\x65\x6e\x74\x41\x63\x71\x75\x69\x72\x65",
"\x52\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x61\x63\x71\x75\x69\x72\x65\x2e"
);(my $response=NXClientSystemDaemons::getDaemonReplyAboutRedis (
$waitingForAcquireTimeout));if (($response ne getMessageStartAcquire ())){if ((
$response eq (""))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x74\x69\x6d\x65\x6f\x75\x74\x3a\x20"
.$waitingForAcquireTimeout)."\x20\x72\x65\x61\x63\x68\x65\x64\x2e"));}else{
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x72\x65\x61\x64\x79\x2e\x20\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x63\x6f\x67\x6e\x69\x7a\x65\x20\x6d\x65\x73\x73\x61\x67\x65\x3a\x20"
.$response)."\x2e"));}NXClientSystemDaemons::closeConnection ();return (
(0x134c+ 2428-0x1cc8));}if ((Common::NXDescriptor::yield ($daemonRedis,
$socketPath,$socketCookie)==(-(0x06a8+ 2791-0x118e)))){Logger::error (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x79\x69\x65\x6c\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x46\x44\x23"
.$daemonRedis).
"\x20\x77\x69\x74\x68\x20\x73\x6f\x63\x6b\x65\x74\x20\x70\x61\x74\x68\x20").
$socketPath)."\x2e"));NXClientSystemDaemons::closeConnection ();main::nxexit (
(0x0867+ 5652-0x1e7a));}($response=(""));($response=
NXClientSystemDaemons::getDaemonReplyAboutRedis ($waitingForRedisDaemonReply));
if (($response eq getMessageAcquireFail ())){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x66\x61\x69\x6c\x65\x64\x2e"
);NXClientSystemDaemons::closeConnection ();main::nxexit ((0x040b+ 3264-0x10ca))
;}if (($response ne getMessageAcquireDone ())){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x72\x65\x63\x6f\x67\x6e\x69\x7a\x65\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x64\x75\x72\x69\x6e\x67\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x3a\x20"
.$response)."\x2e"));NXClientSystemDaemons::closeConnection ();return (
(0x1803+ 899-0x1b86));}Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x4e\x58\x52\x65\x64\x69\x73\x41\x63\x71\x75\x69\x72\x65\x20\x63\x6c\x69\x65\x6e\x74\x20\x61\x66\x74\x65\x72\x20"
.Server::getTimePassedFromSavedTimestamp (
"\x72\x65\x64\x69\x73\x43\x6c\x69\x65\x6e\x74\x41\x63\x71\x75\x69\x72\x65")).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e"));
Common::NXCore::doNotCloseSocketAtFinish ($daemonRedis);
NXClientSystemDaemons::closeConnection ();Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x70\x61\x73\x73\x65\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x74\x6f\x20\x74\x68\x65\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
);}($connected=(0x0100+ 7558-0x1e85));sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6f\x6e\x6e\x65\x63\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x66\x64\x3d"
.$clientRedis)."\x0a"));if ((get ()eq "\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64")){
Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x73\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64\x2e"
);Common::NXCore::doNotCloseSocketAtFinish ($clientRedis);if ((auth ()==
(0x1e95+ 1791-0x2593))){return (initRedisClient ());}($redisServerPid=
__getRedisServerPid ());if (($serverInit==(0x0064+ 3489-0x0e04))){
main::nxrequire ("\x4e\x58\x52\x65\x64\x69\x73\x53\x63\x72\x69\x70\x74");
NXRedisScript::loadAllScriptsToDb ();}if (checkIfSubscriptionShouldBeStarted ())
{main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e");
NXRedisSubscription::createSubscriptionClient ();}}else{Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64\x2e"
);}}sub sendToDb{(my $msg=shift (@_));if ((Server::isDaemonProcess ()and (
$serverInit==(0x15ef+ 3234-0x2291)))){if ((
NXServerDaemon::checkAndSetServerDaemonFlock ()==(0x0a6d+ 350-0x0bcb))){
Logger::error (
"\x41\x6e\x6f\x74\x68\x65\x72\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x20\x69\x6e\x73\x74\x61\x6e\x63\x65\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
);main::nxexit ();}main::nxrequire (
"\x4e\x58\x53\x79\x73\x74\x65\x6d\x44\x61\x65\x6d\x6f\x6e\x73");if (
NXSystemDaemons::savePid ("\x6e\x78\x73\x65\x72\x76\x65\x72",$ $)) {
 Logger::error
 (
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x61\x76\x65\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x20\x70\x69\x64\x2e"
);main::nxexit ();}if ((__checkAndSetRedisServerFlock ()==(0x0385+ 6867-0x1e57))
){initRedisServer ();($waitingForReleaseCounter=(0x18c7+ 531-0x1ada));}else{if (
($waitingForReleaseCounter>$waitingForReleaseSendKill)){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2c\x20\x6f\x74\x68\x65\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x72\x65\x6c\x65\x61\x73\x65\x20\x64\x61\x74\x61\x62\x73\x65\x2e\x20\x45\x78\x69\x74\x69\x6e\x67\x2e"
);main::nxexit ((0x192b+ 441-0x1ae4));}if (($waitingForReleaseCounter==
$waitingForReleaseSendKill)){(my $redisServerPid=__getRedisServerPid ());
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x47\x6f\x69\x6e\x67\x20\x74\x6f\x20\x6b\x69\x6c\x6c\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$redisServerPid).
"\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
));__killOtherRedisServer ($redisServerPid);}Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x4f\x74\x68\x65\x72\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x69\x73\x20\x63\x75\x72\x72\x65\x6e\x74\x6c\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
);main::nxsleep (0.5);(++$waitingForReleaseCounter);return (sendToDb ($msg));}}
main::nxrequire ("\x4e\x58\x53\x79\x73\x74\x65\x6d\x44\x61\x65\x6d\x6f\x6e\x73")
;if ((((((($connected==(0x0761+ 4678-0x19a7))and (
NXSystemDaemons::isShutdownFlag ()==(0x08ff+ 1242-0x0dd9)))and ($redisServerPid
!=(-(0x1999+ 1848-0x20d0))))and ($serverInit==(0x0d72+ 235-0x0e5d)))and (
NXServerDaemon::checkDaemonFlock ()==(0x0320+ 5472-0x187f)))and (
$finalizeProcessStarted==(0x013b+ 2423-0x0ab2)))){(++$waitingForNewDaemonCounter
);main::nxsleep ($waitingForNewDaemonTick);if (($waitingForNewDaemonCounter>=
$timeoutForNewDaemonWaiting)){($redisServerPid=(-(0x01f4+ 4437-0x1348)));(my $logTimeout
=($waitingForNewDaemonCounter *$waitingForNewDaemonTick));(
$waitingForNewDaemonCounter=(0x028c+ 1985-0x0a4d));Logger::error (((
"\x53\x65\x72\x76\x65\x72\x20\x6c\x6f\x73\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x64\x61\x74\x61\x62\x61\x73\x65\x20\x61\x6e\x64\x20\x74\x69\x6d\x65\x6f\x75\x74\x20\x66\x6f\x72\x20\x6e\x65\x77\x20\x6f\x6e\x65\x20"
.$logTimeout).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x20\x72\x65\x61\x63\x68\x65\x64\x2e"));closeDb
 ((0x08af+ 6035-0x2041));main::nxexit ((0x0537+ 8347-0x25d1));}else{return (
sendToDb ($msg));}}($waitingForNewDaemonCounter=(0x08eb+ 1790-0x0fe9));if ((((
$connected==(0x14f2+  53-0x1527))and ($serverInit==(0x0591+ 442-0x074b)))and (
not (Server::isDaemonProcess ())))){if ((NXSystemDaemons::isShutdownFlag ()==
(0x01da+ 2468-0x0b7d))){if ((__checkAndSetRedisServerFlock ()==
(0x205f+ 140-0x20ea))){initRedisServer ();($waitingForReleaseCounter=
(0x0186+ 962-0x0548));}else{removeRedisServerLockFileHandle ();if ((
$waitingForReleaseCounter==$waitingForNonDaemonServerReleaseTimeout)){
Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x20\x6f\x6e\x20\x73\x68\x75\x74\x64\x6f\x77\x6e\x2c\x20\x6f\x74\x68\x65\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x72\x65\x6c\x65\x61\x73\x65\x20\x64\x61\x74\x61\x62\x73\x65\x2e"
);return ((0x0153+ 7864-0x200b));}Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x6f\x6e\x20\x73\x68\x75\x74\x64\x6f\x77\x6e\x2e\x20\x44\x61\x65\x6d\x6f\x6e\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x62\x75\x74\x20\x74\x68\x65\x72\x65\x20\x69\x73\x20\x6c\x6f\x63\x6b\x20\x6f\x6e\x20\x66\x69\x6c\x65\x2e"
);main::nxsleep ($waitIntervalTime);(++$waitingForReleaseCounter);return (
sendToDb ($msg));}}elsif ((NXServerDaemon::checkDaemonFlock ()==
(0x00da+ 6507-0x1a44))){if ((($GLOBAL::isNXServerLoginProcess==
(0x0fb7+ 1715-0x166a))or (($GLOBAL::isNXServerLoginProcess==
(0x0cfd+ 5218-0x215e))and ($finalizeProcessStarted==(0x00a0+ 7907-0x1f82))))){if
 ((__checkAndSetRedisServerFlock ()==(0x1fc7+ 254-0x20c4))){initRedisServer ();(
$waitingForReleaseCounter=(0x05aa+ 533-0x07bf));}else{
removeRedisServerLockFileHandle ();if (($waitingForReleaseCounter==
$waitingForNonDaemonServerReleaseTimeout)){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2c\x20\x6f\x74\x68\x65\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x72\x65\x6c\x65\x61\x73\x65\x20\x64\x61\x74\x61\x62\x73\x65\x2e"
);return ((0x00ac+ 9129-0x2455));}Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e\x20\x44\x61\x65\x6d\x6f\x6e\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x62\x75\x74\x20\x74\x68\x65\x72\x65\x20\x69\x73\x20\x6c\x6f\x63\x6b\x20\x6f\x6e\x20\x66\x69\x6c\x65\x2e"
);main::nxsleep ($waitIntervalTime);(++$waitingForReleaseCounter);return (
sendToDb ($msg));}}else{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x75\x6e\x61\x76\x61\x69\x6c\x61\x62\x6c\x65\x2e\x20\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x64\x61\x74\x61\x62\x61\x73\x65\x20\x61\x73\x20\x6c\x6f\x67\x69\x6e\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
);checkFailCounter ();return ((0x14cb+ 2009-0x1ca4));}}else{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x44\x61\x65\x6d\x6f\x6e\x20\x69\x73\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e\x20\x53\x6b\x69\x70\x70\x69\x6e\x67\x20\x63\x72\x65\x61\x74\x65\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
);}}if (($connected==(0x06a4+ 6439-0x1fcb))){initRedisClient ();}if (($connected
==(0x0b7d+ 5526-0x2113))){Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x6d\x65\x73\x73\x61\x67\x65\x3a\x20\x27"
.$msg).
"\x27\x2e\x20\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x75\x6e\x61\x76\x61\x69\x6c\x61\x62\x6c\x65\x2e"
));return ((0x1077+ 4817-0x2348));}if ((__checkCommandLine ((\$msg))==
(0x01ec+ 8812-0x2457))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x6e\x64\x69\x6e\x67\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x27"
.$msg)."\x27\x20\x61\x62\x6f\x72\x74\x65\x64\x2e"));return (
(0x0270+ 6960-0x1da0));}Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x6e\x64\x69\x6e\x67\x20\x27".$msg)
."\x27\x2e"));if ((main::nxwrite ($readRedis,$msg)==(-(0x01d3+ 1275-0x06cd)))){
if (($retry==(0x0032+ 2079-0x0851))){closeDb ();($retry=(0x1f10+ 1590-0x2545));
sendToDb ($msg);}else{Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x6d\x65\x73\x73\x61\x67\x65\x3a\x20\x27"
.$msg).
"\x27\x2e\x20\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x75\x6e\x61\x76\x61\x69\x6c\x61\x62\x6c\x65\x2e"
));return ((0x07d9+ 5431-0x1d10));}}($retry=(0x01ad+ 6783-0x1c2c));push (
@sendCommandList,$msg);return ((0x16eb+ 1671-0x1d71));}sub sendToDbAndSave{(my $msg
=shift (@_));if ((sendToDb ($msg)==(0x172b+ 2495-0x20e9))){saveDb ();}}sub 
sendToDbAndGetReply{(my $request=shift (@_));if ((sendToDb ($request)==
(0x0dd0+ 2473-0x1778))){return (split ( / / ,get (),(0x001b+ 8586-0x21a5)));}
return (undef);}sub readFromDb{my ($read_buf);(my $bytes_read=main::nxread (
$readRedis,(\$read_buf),32768));if ((($bytes_read eq (0x00f3+ 4262-0x1199))or (
$bytes_read eq ("")))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x73\x6f\x63\x6b\x65\x74\x20\x77\x61\x73\x20\x63\x6c\x6f\x73\x65\x64\x2e"
);$selector->remove ($readRedis);$selector->remove ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});main::nxclose ($readRedis);($readRedis=(""));(
$connected=(0x1310+ 1287-0x1817));return ((""));}else{(my $response=$read_buf);
while ((($bytes_read==32768)or (not (($read_buf=~ /\n$/ ))))){($bytes_read=
main::nxread ($readRedis,(\$read_buf),32768));($response.=$read_buf);}
Logger::debug3 (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x63\x65\x69\x76\x65\x64\x20\x64\x61\x74\x61\x20\x6f\x6e\x20\x52\x65\x64\x69\x73\x20\x73\x6f\x63\x6b\x65\x74\x3a\x20\x27"
.$response)."\x27\x2e"));parseRedisOutput ($response);}}sub get{(my $callbackTimeout
=(shift (@_)||(0x0c48+ 2153-0x14b1)));(my $ref_timeoutCallback=shift (@_));if ((
$sendCommandList[-(0x0658+ 6336-0x1f17)]eq (""))){return ((""));}push (
@waitingCommandList,$sendCommandList[-(0x0d77+ 5161-0x219f)]);(my $tmpLastCommand
=__getCommandNameFromLine ($sendCommandList[-(0x0040+ 6514-0x19b1)]));my (
$returnValue);if ((waitForReponse ($callbackTimeout,$ref_timeoutCallback)==
(0x0744+ 769-0x0a44))){($returnValue=pop (@responses));($failCounter=
(0x1684+ 1583-0x1cb3));Logger::debug3 (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x27"
.$tmpLastCommand)."\x27\x20\x69\x73\x20\x27").$returnValue)."\x27\x2e"));}else{
if ((checkFailure ()==(0x04d0+ 7377-0x21a1))){if ((waitForReponse (
$callbackTimeout,$ref_timeoutCallback)==(0x0dbc+ 3960-0x1d33))){($returnValue=
pop (@responses));($failCounter=(0x06b6+ 5968-0x1e06));Logger::debug3 (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x27"
.$tmpLastCommand)."\x27\x20\x69\x73\x20\x27").$returnValue)."\x27\x2e"));}else{(
@waitingCommandList=());(@responses=());shift (@sendCommandList);Logger::error (
((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x6f\x75\x74\x70\x75\x74\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x3a\x20"
.$tmpLastCommand).
"\x20\x61\x66\x74\x65\x72\x20\x72\x65\x73\x65\x6e\x64\x69\x6e\x67\x2e"));}}else{
Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x6f\x75\x74\x70\x75\x74\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x3a\x20"
.$tmpLastCommand).
"\x20\x52\x65\x73\x65\x6e\x64\x69\x6e\x67\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x73\x20\x66\x61\x69\x6c\x65\x64\x2e"
));}}return ($returnValue);}sub getWithCallbackOnTimeout{(my $callbackTimeout=
shift (@_));(my $ref_timeoutCallback=shift (@_));if (($maxWaitTimeout<
$callbackTimeout)){return (get ());}(my $defaultTimeout=$waitForResponseTimeout)
;($waitForResponseTimeout=$maxWaitTimeout);(my $result=get ($callbackTimeout,
$ref_timeoutCallback));($waitForResponseTimeout=$defaultTimeout);return ($result
);}sub waitForReponse{(my $callbackTimeout=(shift (@_)||(0x1bec+ 1376-0x214c)));
(my $ref_timeoutCallback=shift (@_));(my $waitTime=(0x1989+ 458-0x1b53));(my $waitForResponseTimeout
=($waitForResponseTimeout *1000));(my $maxSelectTimeout=$waitForResponseTimeout)
;if ($callbackTimeout){($maxSelectTimeout=$callbackTimeout);}if (((
__getCommandNameFromLine ($waitingCommandList[(0x0ad0+ 7074-0x2672)])eq 
"\x61\x75\x74\x68")or (__getCommandNameFromLine ($waitingCommandList[
(0x04e6+ 4497-0x1677)])eq "\x65\x76\x61\x6c\x73\x68\x61"))){(
$waitForResponseTimeout=(($NXRedis::waitForResponseTimeout *
(0x09bf+ 7734-0x240d))*(0x0993+ 309-0x0ac2)));($maxSelectTimeout=
$waitForResponseTimeout);}($selectTimeout=$maxSelectTimeout);(my $startTime=
Common::NXTime::getMillisecondsSinceEpoch ());(my $lastTimeoutCallbackCall=
(0x0385+ 5190-0x17cb));while (((@waitingCommandList and ($waitTime<
$waitForResponseTimeout))and (($connected==(0x0c9b+ 5444-0x21de))||(
__getCommandNameFromLine ($waitingCommandList[(0x0c66+ 2797-0x1753)])eq 
"\x63\x6f\x6e\x6e\x65\x63\x74")))){(my (@ready)=$selector->can_read (
$selectTimeout));foreach my $fh (@ready){if (($fh eq $readRedis)){if (
@waitingCommandList){readFromDb ();}}}if (@waitingCommandList){if ((
$resendSuccess==(0x048a+ 2659-0x0eec))){($waitTime=(0x0ab9+ 618-0x0d23));(
$selectTimeout=$maxSelectTimeout);($startTime=
Common::NXTime::getMillisecondsSinceEpoch ());($resendSuccess=
(0x06f0+ 7023-0x225f));}else{($waitTime=(
Common::NXTime::getMillisecondsSinceEpoch ()-$startTime));if ($callbackTimeout){
if ((($waitTime+$selectTimeout)>$waitForResponseTimeout)){($selectTimeout=(
$waitForResponseTimeout-$waitTime));}}else{($selectTimeout=($maxSelectTimeout-
$waitTime));}}if ($callbackTimeout){if ((($lastTimeoutCallbackCall+
$callbackTimeout)<Common::NXTime::getSecondsSinceEpoch ())){&{
$ref_timeoutCallback;}();($lastTimeoutCallbackCall=
Common::NXTime::getSecondsSinceEpoch ());}}}}if (($connected!=
(0x09c6+ 4043-0x1990))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6c\x69\x65\x6e\x74\x20\x77\x61\x73\x20\x64\x69\x73\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64\x2c\x20\x71\x75\x69\x74\x20\x77\x61\x69\x74\x69\x6e\x67\x2e"
);return ((0x1336+ 4354-0x2438));}if (@waitingCommandList){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x54\x69\x6d\x65\x6f\x75\x74\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.__getCommandNameFromLine ($waitingCommandList[(0x0830+ 5539-0x1dd3)])).((
"\x20\x77\x68\x69\x63\x68\x20\x69\x73\x20".$NXRedis::waitForResponseTimeout).
"\x20\x68\x61\x73\x20\x62\x65\x65\x6e\x20\x72\x65\x61\x63\x68\x65\x64\x2e")));
checkFailCounterAndCloseIfNeeded ();return ((0x019a+ 7887-0x2069));}return (
(0x0a02+ 539-0x0c1c));}sub parseRedisOutput{(my $output=shift (@_));($output.=
"\x20");(my (@lines)=split ( /\n/ ,$output,(0x0bab+ 5573-0x2170)));while (@lines
){(my $line=shift (@lines));if (($line=~ /event=disconnected,error=0/ )){(
$connected=(0x0501+ 3067-0x10fc));next;}(my $response=shift (@lines));unless (
@sendCommandList){return;}my ($firstWaitingCommand);if (@waitingCommandList){(
$firstWaitingCommand=__getCommandNameFromLine ($waitingCommandList[
(0x0615+ 7709-0x2432)]));}if ((handleCommandSuccesful ($line)==
(0x1bcf+ 766-0x1ecc))){return;}if (($line=~ /command=connect,error=0/ )){
Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x6e\x6e\x65\x63\x74\x65\x64\x2e");
($connected=(0x07c7+ 7041-0x2347));shift (@waitingCommandList);push (@responses,
"\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64");next;}elsif (($line=~ /command=connect,error=/ )
){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x4e\x6f\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x2e"
);shift (@waitingCommandList);push (@responses,
"\x64\x69\x73\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64");($connected=
(0x097a+ 5819-0x2035));next;}elsif ((($line=~ /command=(.*),error=0/ )and (
$response ne ("")))){(my $command=$1);if (($command eq $firstWaitingCommand)){(my $fullResponse
=$response);if (($command eq "\x63\x6c\x69\x65\x6e\x74")){while ((@lines and (
$lines[(0x059c+ 6576-0x1f4c)]=~ /^id=/ ))){($fullResponse.=("\x0a".shift (@lines
)));}}push (@responses,$fullResponse);shift (@waitingCommandList);next;}else{
Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$firstWaitingCommand)."\x2e"));}}elsif ((($line=~ /command=(.*),error=0,size=0/ )
and ($response eq ("")))){(my $command=$1);if (($command eq $firstWaitingCommand
)){Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x6e\x6f\x20\x76\x61\x6c\x75\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.__getCommandNameFromLine ($waitingCommandList[(0x0c5f+ 6437-0x2584)])).
"\x20\x73\x61\x76\x65\x64\x20\x69\x6e\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"))
;push (@responses,(""));shift (@waitingCommandList);next;}else{Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$firstWaitingCommand)."\x2e"));}}elsif ((($line=~ /command=bgsave,error=1/ )and
 ($response=~ /ERR Background save already in progress/ ))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x73\x61\x76\x69\x6e\x67\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x69\x6e\x20\x70\x72\x6f\x67\x72\x65\x73\x73\x2c\x20\x73\x6b\x69\x70\x69\x6e\x67\x2e"
);push (@responses,(""));shift (@waitingCommandList);shift (@sendCommandList);
next;}elsif (($line=~ /command=(.*),error=(.*)/ )){(my $error=$2);(
$errorDuringLastCommand=(0x08cd+ 4326-0x19b2));if (($error ne (""))){if ((
__handleRedisErrorIfPossible ($response)==(0x1cb6+ 746-0x1f9f))){return;}
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x6d\x6d\x61\x6e\x64\x20\x27".
__getCommandNameFromLine ($sendCommandList[(0x12ba+ 1711-0x1969)])).((((
"\x27\x20\x66\x61\x69\x6c\x65\x64\x20\x6f\x6e\x20\x72\x65\x64\x69\x73\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$error)."\x3a\x20").$response).
"\x20\x4d\x6f\x72\x65\x20\x69\x6e\x66\x6f\x72\x6d\x61\x74\x69\x6f\x6e\x20\x69\x6e\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x2e\x6c\x6f\x67\x2e"
)));}else{Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x6d\x6d\x61\x6e\x64\x20\x27".
__getCommandNameFromLine ($sendCommandList[(0x18f9+ 2467-0x229c)])).
"\x27\x20\x66\x61\x69\x6c\x65\x64\x20\x6f\x6e\x20\x72\x65\x64\x69\x73\x2e\x20\x4d\x6f\x72\x65\x20\x69\x6e\x66\x6f\x72\x6d\x61\x74\x69\x6f\x6e\x20\x69\x6e\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x2e\x6c\x6f\x67\x2e"
));}($connected=(0x1990+ 927-0x1d2f));}elsif (($line eq (""))){next;}elsif ((
$response=~ /event=disconnected,error=0/ )){($connected=(0x118d+ 1405-0x170a));
next;}}}sub getRedisDescriptor{return ($readRedis);}sub saveDb{Logger::debug (
"\x53\x61\x76\x69\x6e\x67\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);if (($serverInit==(0x1398+ 1331-0x18ca))){sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x61\x76\x65\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}else{sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x62\x67\x73\x61\x76\x65\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}(my $saveResponse=get ());}sub closeDb{(my $finalizeProcess=(shift (@_)||
(0x016c+ 3415-0x0ec3)));if (($finalizeProcess==(0x0028+ 3108-0x0c4b))){(
$finalizeProcessStarted=(0x07fb+ 4693-0x1a4f));}Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6c\x6f\x73\x69\x6e\x67\x20\x64\x62\x2e"
);while ((scalar (@sendCommandList)>(0x1963+ 2085-0x2188))){(my $command=
__getCommandNameFromLine ($sendCommandList[(0x074d+ 7833-0x25e6)]));
Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x27"
.$command).
"\x27\x20\x62\x65\x66\x6f\x72\x65\x20\x63\x6c\x6f\x73\x69\x6e\x67\x2e"));get ();
}if (($doNotCloseRedisThreadsWhenFreePerl==(0x0aa4+  87-0x0afa))){Logger::debug 
(
"\x4c\x65\x61\x76\x69\x6e\x67\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x61\x6e\x64\x20\x72\x65\x64\x69\x73\x20\x73\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x74\x68\x72\x65\x61\x64\x2e"
);return;}main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e");
NXRedisSubscription::closeSubscription ();if (($connected==(0x0063+ 8054-0x1fd8)
)){Logger::debug (
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x6c\x69\x65\x6e\x74\x44\x65\x73\x74\x72\x6f\x79\x28\x29"
);(my $returnValue=libnxhs::NXRedisClientDestroy ());Logger::debug (((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x6c\x69\x65\x6e\x74\x44\x65\x73\x74\x72\x6f\x79\x28\x29\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$returnValue)."\x27\x2e"));Common::NXSelector::removeFromGlobalSelector (
$readRedis);($readRedis=(""));($connected=(0x18cf+ 2963-0x2462));}if ((
$serverInit==(0x0346+ 3816-0x122d))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6c\x6f\x73\x69\x6e\x67\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
);if ((libnxhs::NXRedisServerDestroy ()==(0x16d1+ 2916-0x2234))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x72\x76\x65\x72\x20\x77\x61\x73\x20\x63\x6c\x6f\x73\x65\x64\x2e"
);removeRedisServerLockFileHandle ();(my $redisLock=getRedisLockFile ());if ((
not (unlink ($redisLock)))){Logger::warning ((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x75\x6e\x6c\x69\x6e\x6b\x20\x66\x69\x6c\x65\x20"
.$redisLock)."\x2e\x20").$!));}(my $redisPidFile=getRedisPidFile ());if ((not (
unlink ($redisPidFile)))){Logger::warning ((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x75\x6e\x6c\x69\x6e\x6b\x20\x66\x69\x6c\x65\x20"
.$redisLock)."\x2e\x20").$!));}(my $dbFile=NXPaths::getRedisDatabaseFile ());if 
(Common::NXFile::fileExists ($dbFile)){my ($errorMsg);if ((
Common::NXFile::setOwnershipForUserNX ($dbFile,(\$errorMsg))==(-
(0x0cb0+ 4743-0x1f36)))){Logger::warning (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x72\x65\x64\x69\x73\x20\x66\x69\x6c\x65\x20\x27"
.$dbFile)."\x27\x20").$errorMsg)."\x2e"));}}}else{Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x63\x6c\x6f\x73\x65\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
);}($serverInit=(0x19a2+ 1630-0x2000));}}sub isRedisDatabaseInit{if (
Server::isDaemonProcess ()){if (($serverInit==(0x1548+ 1981-0x1d04))){return (
(0x143f+ 4619-0x2649));}else{return ((0x107f+ 1429-0x1614));}}if (
isRedisLockFileExist ()){return ((0x0d4b+ 5153-0x216b));}else{return (
(0x0a07+ 5729-0x2068));}}sub getRedisLockFile{(my $redisLockFile=((((((
$GLOBAL::VAR_ROOT.$GLOBAL::DIRECTORY_SLASH)."\x64\x62").$GLOBAL::DIRECTORY_SLASH
)."\x73\x65\x72\x76\x65\x72").$GLOBAL::DIRECTORY_SLASH)."\x72\x65\x64\x69\x73"))
;return ($redisLockFile);}sub getRedisPidFile{(my $redisPidFile=((((((
$GLOBAL::VAR_ROOT.$GLOBAL::DIRECTORY_SLASH)."\x64\x62").$GLOBAL::DIRECTORY_SLASH
)."\x73\x65\x72\x76\x65\x72").$GLOBAL::DIRECTORY_SLASH).
"\x72\x65\x64\x69\x73\x2e\x70\x69\x64"));return ($redisPidFile);}sub 
isRedisLockFileExist{(my $file=getRedisLockFile ());if (
Common::NXFile::fileExists ($file)){return ((0x0350+ 3060-0x0f43));}else{return 
((0x06da+ 8222-0x26f8));}}sub isNotRedisDatabaseInit{return ((!
isRedisDatabaseInit ()));}sub daemonAcquire{(my $message=shift (@_));(my $socket
=shift (@_));(my (%parameters)=());(my $redisDescriptor=(-(0x128d+ 4535-0x2443))
);if (($serverInit==(0x0e02+ 4565-0x1fd7))){return ((0x04f0+ 748-0x07db));}if ((
$message=~ /Redis yield/ )){($message=~ s/Redis yield // );(my (@args)=split ( / / ,
$message,(0x0bc3+ 3383-0x18fa)));foreach my $pair (@args){(my ($key,$value)=
split ( /=/ ,$pair,(0x0236+ 2304-0x0b33)));($parameters{$key}=$value);}(my $socketPath
=main::urldecode ($parameters{
"\x73\x6f\x63\x6b\x65\x74\x50\x61\x74\x68\x45\x6e\x63\x6f\x64\x65\x64"}));(my $msg
=getMessageStartAcquire ());if ((main::nxwrite ($socket,$msg)==(-
(0x06f3+ 5874-0x1de4)))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x69\x6e\x66\x6f\x72\x6d\x20\x73\x65\x72\x76\x65\x72\x20"
.$parameters{"\x70\x69\x64"}).
"\x20\x61\x62\x6f\x75\x74\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x72\x65\x61\x64\x79\x2e"
));return ((0x09c7+ 1988-0x118a));}($redisDescriptor=
Common::NXDescriptor::acquire ($parameters{"\x70\x69\x64"},$parameters{
"\x66\x64"},$socketPath,$parameters{
"\x73\x6f\x63\x6b\x65\x74\x43\x6f\x6f\x6b\x69\x65"}));if ((($redisDescriptor<
(0x0329+ 2814-0x0e27))or ($redisDescriptor>$descriptorLimit))){Logger::warning (
((((
"\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x66\x72\x6f\x6d\x20\x73\x65\x72\x76\x65\x72\x20"
.$parameters{"\x70\x69\x64"})."\x20\x61\x6e\x64\x20").$socketPath)."\x2e"));(
$msg=getMessageAcquireFail ());if ((main::nxwrite ($socket,$msg)==(-
(0x09e1+ 2955-0x156b)))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x69\x6e\x66\x6f\x72\x6d\x20\x73\x65\x72\x76\x65\x72\x20"
.$parameters{"\x70\x69\x64"}).
"\x20\x61\x62\x6f\x75\x74\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x66\x61\x69\x6c\x2e"
));}return ((0x0db9+ 5272-0x2250));}Common::NXCore::doNotCloseSocketAtFinish (
$redisDescriptor);Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x72\x65\x63\x65\x69\x76\x65\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x46\x44\x23"
.$redisDescriptor)."\x20\x66\x72\x6f\x6d\x20\x73\x65\x72\x76\x65\x72\x2e"));(my $return
=libnxhs::NXRedisServerConnection ($redisDescriptor));Logger::debug (((((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x28"
.$redisDescriptor)."\x29\x20").$return)."\x2e"));($msg=getMessageAcquireDone ())
;if ((main::nxwrite ($socket,$msg)==(-(0x0ec4+ 5483-0x242e)))){Logger::warning (
((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x69\x6e\x66\x6f\x72\x6d\x20\x73\x65\x72\x76\x65\x72\x20"
.$parameters{"\x70\x69\x64"}).
"\x20\x61\x62\x6f\x75\x74\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x6f\x6e\x65\x2e"
));}return ((0x02c2+ 8687-0x24b1));}else{Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x68\x61\x6e\x64\x6c\x65\x20\x72\x65\x64\x69\x73\x20\x79\x69\x65\x6c\x64\x20\x72\x65\x71\x75\x65\x73\x74\x3a\x20"
.$message)."\x2e"));return ((0x1d54+ 1150-0x21d1));}}sub 
isDbRunningInCurrentProcess{return ($serverInit);}sub __lockFile{(my $file=
getRedisLockFile ());my ($errormsg);(my $SERVER_FH=main::nxopen ($file,(
$NXBits::O_WRONLY+$NXBits::O_CREAT),(($NXBits::UserReadWrite+$NXBits::GroupRead)
+$NXBits::OthersRead)));if ((not (defined ($SERVER_FH)))){(my $serverDir=
Common::NXFile::dirname ($file));if ((Common::NXFile::directoryExists (
$serverDir)==(0x0b49+  27-0x0b64))){my ($errorMessage);if (
Common::NXPaths::makePath ((\$errorMessage),$serverDir)){if ((
Common::NXFile::setOwnershipForUserNX ($serverDir,(\$errorMessage))==(-
(0x04b3+ 3617-0x12d3)))){Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x4e\x58\x20\x66\x6f\x72\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20"
.$serverDir)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20").$errorMessage).
"\x2e"));}if ((Common::NXFile::setPermissionsFullForNXDirectory ($serverDir,(
\$errorMessage))==(-(0x1f45+ 161-0x1fe5)))){Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x63\x6f\x72\x72\x65\x63\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x66\x6f\x72\x20\x75\x73\x65\x72\x20\x4e\x58\x20\x66\x6f\x72\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20"
.$serverDir)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20").$errorMessage).
"\x2e"));}($SERVER_FH=main::nxopen ($file,($NXBits::O_WRONLY+$NXBits::O_CREAT),(
($NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead)));}else{
Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20"
.$serverDir)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20").$errorMessage).
"\x2e"));}}if ((not (defined ($SERVER_FH)))){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20\x27"
.$file)."\x27\x20\x66\x6f\x72\x20\x77\x72\x69\x74\x69\x6e\x67\x2e"));return ((-
(0x0080+ 8738-0x22a1)));}}unless (main::nxflock ($SERVER_FH,$NXBits::LOCK_EX)){
Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x66\x6c\x6f\x63\x6b\x20\x66\x69\x6c\x65\x3a\x20"
.$file)."\x2e"));return ((-(0x0d38+ 790-0x104d)));}
Common::NXFile::setOwnershipForUserNX ($file,(\$errormsg));if (($errormsg ne 
(""))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x63\x68\x61\x6e\x67\x65\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x6c\x6f\x63\x6b\x20\x66\x69\x6c\x65\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$errormsg)."\x2e"));}libnxh::NXDescriptorInheritable ($SERVER_FH,
(0x1c72+ 2412-0x25de));main::closeSocketAtFinish ($SERVER_FH);return ($SERVER_FH
);}sub __checkAndSetRedisServerFlock{if (($serverInit==(0x0793+ 234-0x087c))){
return ((0x1056+ 1372-0x15b2));}if ((not (checkRedisFlock ()))){return (
(0x0002+ 5180-0x143e));}else{unless ((main::effectiveUserIsAdministrator ()or (
Common::NXCore::getEffectiveUsername ()eq "\x6e\x78"))){if ((
NXSystemDaemons::isShutdownFlag ()==(0x1c39+ 2421-0x25ad))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x6e\x74\x69\x6e\x75\x65\x2c\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x69\x73\x20\x73\x68\x75\x74\x64\x6f\x77\x6e\x20\x61\x6e\x64\x20\x72\x65\x71\x75\x65\x73\x74\x65\x64\x20\x6f\x70\x65\x72\x61\x74\x69\x6f\x6e\x20\x72\x65\x71\x75\x69\x72\x65\x73\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x74\x69\x6e\x75\x65\x4e\x78\x73\x65\x72\x76\x65\x72\x53\x68\x75\x74\x64\x6f\x77\x6e"
,"\x4e\x58\x52\x65\x64\x69\x73");main::nxexit ((0x01fc+ 8084-0x2190));}}(my $file
=getRedisLockFile ());unlink ($file);(my $fh=__lockFile ());if (($fh==(-
(0x1de4+ 260-0x1ee7)))){return ((0x0020+ 302-0x014e));}
setRedisServerLockFileHandle ($fh);saveRedisPid ();return ((0x0ab1+ 7143-0x2697)
);}}sub checkRedisFlock{if (($serverInit==(0x1bc1+ 2016-0x23a0))){return (
(0x002f+ 9923-0x26f2));}(my $file=getRedisLockFile ());Logger::debug (((
"\x43\x68\x65\x63\x6b\x69\x6e\x67\x20\x72\x65\x64\x69\x73\x20\x66\x69\x6c\x65\x20\x6c\x6f\x63\x6b\x3a\x20"
.$file)."\x2e"));if ((Common::NXFile::fileExists ($file)==(0x0828+ 2558-0x1226))
){Logger::debug ((("\x46\x69\x6c\x65\x20".$file).
"\x20\x64\x6f\x65\x73\x20\x6e\x6f\x74\x20\x65\x78\x69\x73\x74\x2e"));return (
(0x12c1+ 1016-0x16b8));}(my $SERVER_FH=main::nxopen ($file,$NXBits::O_RDONLY,
(0x02af+ 8265-0x22f8)));if ((not (defined ($SERVER_FH)))){Logger::debug (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x3a\x20".$file
)."\x2e"));return ((0x0039+ 8352-0x20d9));}if ((not (Common::NXCore::nxTryLock (
$SERVER_FH,$NXBits::LOCK_EX)))){Logger::debug (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6c\x6f\x63\x6b\x20\x66\x69\x6c\x65\x3a\x20".$file
)."\x2e"));main::nxclose ($SERVER_FH);if ((not (Server::isDaemonProcess ()))){
checkFailCounter ();}return ((0x12a6+ 497-0x1497));}main::nxclose ($SERVER_FH);
return ((0x1297+ 2638-0x1ce4));}sub removeRedisServerLockFileHandle{if ((
$lockFileHandle!=(-(0x1a74+ 2601-0x249c)))){main::nxclose ($lockFileHandle);(
$lockFileHandle=(-(0x0571+ 7130-0x214a)));}}sub setRedisServerLockFileHandle{(
$lockFileHandle=shift (@_));}sub setNxDirInNXHomeDirOwner{(my $path=
NXPaths::getUserNXHomeDir ());my ($errorMsg);if (($path eq (""))){return (
(0x0d3d+ 4192-0x1d9d));}if ((Common::NXFile::directoryExists ($path)==
(0x143a+ 4120-0x2452))){if ((not (Common::NXPaths::makePath ((\$errorMsg),$path)
))){Logger::warning (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20"
.$path)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20").$errorMsg)."\x2e"));
return ((0x00ad+ 1004-0x0499));}}Common::NXFile::setOwnershipForUserNX ($path,(
\$errorMsg));Common::NXFile::setPermissionsFullForNXDirectory ($path,(\$errorMsg
));libnxh::NXTransSetEnvironment ("\x48\x4f\x4d\x45",$path);($path.=(
$GLOBAL::DIRECTORY_SLASH."\x2e\x6e\x78"));if ((Common::NXFile::directoryExists (
$path)==(0x093a+ 7628-0x2706))){Common::NXPaths::createAccessibleForNXDirectory 
((\$errorMsg),$path);}else{Common::NXFile::setOwnershipForUserNX ($path,(
\$errorMsg));Common::NXFile::setPermissionsFullForNXDirectory ($path,(\$errorMsg
));}}sub getMessageStartAcquire{(my $msg=
"\x4e\x58\x52\x65\x64\x69\x73\x20\x73\x74\x61\x72\x74\x65\x64\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x2e"
);return ($msg);}sub getMessageAcquireDone{(my $msg=
"\x4e\x58\x52\x65\x64\x69\x73\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x61\x64\x64\x65\x64\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x2e"
);return ($msg);}sub getMessageAcquireFail{(my $msg=
"\x4e\x58\x52\x65\x64\x69\x73\x20\x63\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x61\x64\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x2e"
);return ($msg);}sub __killOtherRedisServer{(my $serverPid=shift (@_));if (
NXTerminate::checkProcessBeforeKill ($serverPid,
"\x6e\x78\x73\x65\x72\x76\x65\x72",$ $)) {
 if (Common::NXProcess::sigterm (
$serverPid)){Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x54\x65\x72\x6d\x69\x6e\x61\x74\x65\x64\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x50\x49\x44\x20"
.$serverPid)."\x2e"));}else{Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x54\x45\x52\x4d\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x50\x49\x44\x20"
.$serverPid)."\x2e"));}(my $result=Common::NXProcess::waitProcess ($serverPid,
(0x1882+ 2711-0x230a)));if (NXTerminate::checkProcessBeforeKill ($serverPid,
"\x6e\x78\x73\x65\x72\x76\x65\x72",$ $)) {
 if (Common::NXProcess::sigkill (
$serverPid)){if ((not (unlink ($redisLock)))){Logger::warning ((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x75\x6e\x6c\x69\x6e\x6b\x20\x66\x69\x6c\x65\x20"
.$redisLock)."\x2e\x20").$!));}Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x4b\x69\x6c\x6c\x65\x64\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x50\x49\x44\x20"
.$serverPid)."\x2e"));}else{Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x4b\x49\x4c\x4c\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x50\x49\x44\x20"
.$serverPid)."\x2e"));}}}}sub __getRedisServerPid{(my $redisLockFile=
getRedisPidFile ());(my $pid=(-(0x210c+ 1053-0x2528)));my ($FH);($FH=
main::nxopen ($redisLockFile,$NXBits::O_RDONLY,(0x0e3b+ 3209-0x1ac4)));if ((not 
(defined ($FH)))){(my $errorstring=libnxh::NXGetErrorString ());Logger::error ((
(((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x3a\x20"
.$redisLockFile)."\x3a\x20").$errorstring)."\x2e"));return ((""));}else{(my $r_b
=main::nxread ($FH,(\$pid),(0x0c33+ 874-0x0d9d)));main::nxclose ($FH);if (($r_b
==(0x22b6+ 806-0x25dc))){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x66\x69\x6e\x64\x20\x70\x69\x64\x20\x69\x6e\x3a\x20"
.$redisLockFile)."\x2e"));}}return ($pid);}sub __getCommandNameFromLine{(my $cmdLine
=shift (@_));(my $commandName=(""));(($commandName)=($cmdLine=~ /command=(.*),service/ )
);if (($commandName eq (""))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6e\x61\x6d\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$cmdLine)."\x27\x2e"));}return ($commandName);}sub __checkCommandLine{(my $ref_msg
=shift (@_));(my $msg=$$ref_msg);if ((($msg=~ /key=\n/ )or ($msg=~ /key=,/ ))){
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x6b\x65\x79\x20\x69\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$msg).
"\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"));
return ((0x1694+ 977-0x1a64));}if ((($msg=~ / / )and (not (($msg=~ /command=script,service=db,/ )
)))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$msg).
"\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x6e\x74\x61\x69\x6e\x20\x73\x70\x61\x63\x65\x73\x2e"
));return ((0x028f+ 8172-0x227a));}if (($msg=~ /^(.*),field=(.*),value=,/ )){
Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x69\x65\x6c\x64\x20".$2).
"\x20\x69\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27").$msg
)."\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"));(
$$ref_msg=~ s/,field=$2,value=,/,/ );return (__checkCommandLine ($ref_msg));}if 
(($msg=~ /^(.*),field=(.*),value=\n/ )){Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x69\x65\x6c\x64\x20".$2).
"\x20\x69\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27").$msg
)."\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"));(
$$ref_msg=~ s/,field=$2,value=\n/\n/ );return (__checkCommandLine ($ref_msg));}
if ((($msg=~ /=,/ )or ($msg=~ /=\n/ ))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x65\x6d\x70\x74\x79\x20\x66\x69\x65\x6c\x64\x20\x69\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$msg)."\x27\x2e"));return ((0x0689+ 6753-0x20e9));}if ((not (($msg=~ /\n$/ ))))
{Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x6d\x69\x73\x73\x69\x6e\x67\x20\x6e\x65\x77\x20\x6c\x69\x6e\x65\x20\x63\x68\x61\x72\x61\x63\x74\x65\x72\x20\x61\x74\x20\x74\x68\x65\x20\x65\x6e\x64\x20\x6f\x66\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x27"
.$msg)."\x27\x2e"));($$ref_msg.="\x0a");return (__checkCommandLine ($ref_msg));}
if ((($msg=~ /command=(hmset|hset|set),service=db/ )and ((not (($msg=~ /field=(.*)/ )
))and (not (($msg=~ /value=(.*)/ )))))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$msg).
"\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6e\x6f\x74\x68\x69\x6e\x67\x2e"
));return ((0x099b+ 3996-0x1936));}if (((length ($msg)>16383)and (not (($msg=~ /command=evalsha,service=db,/ )
)))){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x69\x73\x20\x6c\x6f\x6e\x67\x65\x72\x20\x74\x68\x61\x74\x20\x63\x75\x72\x72\x65\x6e\x74\x20\x6d\x61\x78\x20\x63\x68\x61\x72\x61\x63\x74\x65\x72\x73\x20\x73\x65\x74\x74\x69\x6e\x67\x73\x3a\x20\x31\x36\x33\x38\x33\x2e"
);return ((0x1609+ 4140-0x2634));}return ((0x0df9+ 5536-0x2399));}sub 
resendWaitingCommands{(my $resend=(0x0b99+ 6514-0x250b));(my (@newCommandList)=
());unless (@sendCommandList){return ((0x0c0b+ 1309-0x1128));}(my (
@tmpCommandList)=@sendCommandList);(@waitingCommandList=());(@sendCommandList=()
);foreach my $command (@tmpCommandList){if (($command=~ /command=connect/ )){
next;}if (($command=~ /command=auth/ )){next;}if ((sendToDb ($command)==
(0x0831+ 112-0x08a1))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x72\x65\x73\x65\x6e\x64\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$command)."\x2e"));last;}else{push (@newCommandList,$command);}}if (
@newCommandList){Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x73\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x72\x65\x73\x65\x6e\x64\x20"
.join ($",@newCommandList))."\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x73\x2e"));(
$resendSuccess=(0x0122+ 471-0x02f8));(@waitingCommandList=@newCommandList);(
@sendCommandList=@newCommandList);return ((0x0f9d+ 428-0x1148));}return (
(0x004f+ 2678-0x0ac5));}sub checkFailure{if (checkRedisFlock ()){($connected=
(0x0358+  71-0x039f));(my $redisLockFile=getRedisLockFile ());if ((
Common::NXFile::fileExists ($redisLockFile)==(0x064f+ 7607-0x2405))){unlink (
$redisLockFile);}}if ((($connected==(0x09b8+ 4587-0x1ba3))or (
__checkIfActualRedisServerPid ()==(0x06f4+ 288-0x0814)))){($connected=
(0x0c9b+ 2148-0x14ff));$selector->remove ($readRedis);$selector->remove (
$$NXBegin::parser{"\x53\x69\x67\x6e\x61\x6c"});if ((resendWaitingCommands ()==
(0x0b73+ 1263-0x1061))){return ((0x01d9+ 5988-0x193d));}return (
(0x055c+ 1351-0x0aa2));}return ((0x0cf4+ 2827-0x17ff));}sub 
__checkIfActualRedisServerPid{my ($actualRedisServerPid);if (($redisServerPid==(
-(0x18d8+ 3015-0x249e)))){return ((0x0dcf+ 5788-0x246b));}if ((
Common::NXFile::fileExists (getRedisLockFile ())==(0x11ac+ 2774-0x1c81))){(
$actualRedisServerPid=__getRedisServerPid ());}else{return ((0x1abd+ 167-0x1b64)
);}if (($actualRedisServerPid==$redisServerPid)){return ((0x08dc+ 3304-0x15c3));
}return ((0x0ea4+ 794-0x11be));}sub prepareMultipleCommands{sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x6d\x75\x6c\x74\x69\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}sub executeCommands{sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x65\x78\x65\x63\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}sub executeCommandsAndSave{sendToDbAndSave (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x65\x78\x65\x63\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}sub isConnected{return ($connected);}sub setDisconnected{($connected=
(0x18d2+ 3404-0x261e));}sub __handleRedisErrorIfPossible{(my $response=shift (@_
));if (($response=~ /LOADING Redis is loading the dataset in memory/ )){
resendWaitingCommands ();return ((0x0766+ 2285-0x1052));}elsif (($response=~ /ERR unknown command/ )
){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x75\x6e\x6b\x6e\x6f\x77\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$waitingCommandList[(0x1041+ 3986-0x1fd3)]).
"\x2e\x20\x53\x6b\x69\x70\x70\x69\x6e\x67"));shift (@waitingCommandList);shift (
@sendCommandList);resendWaitingCommands ();return ((0x141d+ 3232-0x20bc));}elsif
 (($response=~ /Error compiling script/ )){main::nxexit ((0x134a+ 363-0x14b5));}
elsif (($response=~ /Error running script/ )){main::nxexit (
(0x047f+ 1810-0x0b91));}elsif (($response=~ /WRONGTYPE/ )){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x72\x6f\x6e\x67\x20\x74\x79\x70\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$waitingCommandList[(0x0585+ 4948-0x18d9)]).
"\x2e\x20\x53\x6b\x69\x70\x70\x69\x6e\x67\x2e"));shift (@waitingCommandList);
shift (@sendCommandList);resendWaitingCommands ();return ((0x188f+ 1190-0x1d34))
;}elsif (($response=~ /ERR wrong number of arguments/ )){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x72\x6f\x6e\x67\x20\x6e\x75\x6d\x62\x65\x72\x20\x6f\x66\x20\x61\x72\x67\x75\x65\x6d\x6e\x74\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$waitingCommandList[(0x0194+ 9092-0x2518)]).
"\x2e\x20\x53\x6b\x69\x70\x70\x69\x6e\x67\x2e"));shift (@waitingCommandList);
shift (@sendCommandList);resendWaitingCommands ();return ((0x160b+ 2084-0x1e2e))
;}elsif (($response=~ /NOSCRIPT No matching script/ )){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x72\x65\x71\x75\x65\x73\x74\x65\x64\x20\x73\x63\x72\x69\x70\x74\x20\x27"
.$waitingCommandList[(0x0fc5+ 1863-0x170c)]).
"\x27\x20\x6e\x6f\x74\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
));shift (@waitingCommandList);shift (@sendCommandList);
NXRedisScript::loadAllScriptsToDb ();return ((0x0049+ 2496-0x0a08));}return (
(0x0e04+ 4367-0x1f13));}sub saveRedisPid{(my $pidFile=getRedisPidFile ());(my $PID_FH
=main::nxopen ($pidFile,(($NXBits::O_WRONLY+$NXBits::O_CREAT)+$NXBits::O_TRUNC),
(($NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead)));if (defined 
($PID_FH)){main::nxwrite ($PID_FH,$ $);
 main::nxclose ($PID_FH);if (
main::effectiveUserIsAdministrator ()){my ($errorMsg);if ((
Common::NXFile::setOwnershipForUserNX ($pidFile,(\$errorMsg))==(-
(0x1982+ 1958-0x2127)))){Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x69\x6c\x65\x20\x27"
.$pidFile)."\x27\x20").$errorMsg)."\x2e"));}}}else{(my $error=
libnxh::NXGetErrorName ());Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20\x74\x6f\x20\x73\x61\x76\x65\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x70\x69\x64\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$error)."\x2e"));}}sub checkIfLastOperationWentOk{($errorDuringLastCommand=
(0x1045+ 5536-0x25e5));(my $result=get ());if ((($result ne (""))and (
$errorDuringLastCommand==(0x0318+ 7296-0x1f98)))){return ((0x017c+ 6303-0x1a1a))
;}return ((0x0c54+ 1209-0x110d));}sub checkIfSubscriptionShouldBeStarted{if ((
$serverInit==(0x11d1+ 4694-0x2427))){return ((0x0955+ 3468-0x16e0));}elsif (
Server::isDaemonProcess ()){return ((0x08c3+ 3935-0x1821));}else{return (
(0x1577+ 1161-0x1a00));}}sub setServerType{(my $type=shift (@_));(my $name=(""))
;sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6c\x69\x65\x6e\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x67\x65\x74\x6e\x61\x6d\x65\x0a"
);(my $oldName=get ());($oldName=main::urldecode ($oldName));if ((($oldName eq 
(""))or ($oldName eq "\x6e\x6f\x74\x20\x73\x65\x74"))){($name=$type);}else{(
$name=(($oldName."\x20").$type));}($name=main::urlencode ($name));sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6c\x69\x65\x6e\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x73\x65\x74\x6e\x61\x6d\x65\x2c\x76\x61\x6c\x75\x65\x3d"
.$name)."\x0a"));}sub unsetServerType{(my $type=shift (@_));(my $name=(""));
sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6c\x69\x65\x6e\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x67\x65\x74\x6e\x61\x6d\x65\x0a"
);(my $oldName=get ());($oldName=main::urldecode ($oldName));if (($oldName=~ /$type/ )
){($name=$oldName);($name=~ s/ \b$type\b// );($name=~ s/\b$type\b *// );if ((
$name eq (""))){($name="\x6e\x6f\x74\x20\x73\x65\x74");}($name=main::urlencode (
$name));sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6c\x69\x65\x6e\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x73\x65\x74\x6e\x61\x6d\x65\x2c\x76\x61\x6c\x75\x65\x3d"
.$name)."\x0a"));}}sub handleCommandSuccesful{(my $command=shift (@_));if ((
$command eq (""))){return ((0x1019+ 5214-0x2477));}if (($command=~ /command=(.*),error=0/ )
){if (($command=~ /command=multi/ )){($multiCommand=(0x130a+ 2364-0x1c45));
return ((0x1c79+ 1857-0x23ba));}if ((($command=~ /command=exec/ )and (
$multiCommand>(0x0a46+ 6043-0x21e1)))){splice (@sendCommandList,
(0x1107+ 3269-0x1dcc),($multiCommand+(0x04c4+ 7469-0x21f0)));($multiCommand=
(0x08c3+ 5243-0x1d3e));return ((0x0079+ 8913-0x234a));}if (($multiCommand>
(0x00da+ 7630-0x1ea8))){(++$multiCommand);return ((0x1117+ 4788-0x23cb));}(my $firstSendCommand
=__getCommandNameFromLine ($sendCommandList[(0x2215+  58-0x224f)]));if ((
$command=~ /command=(.*),error/ )){(my $receivedCommand=$1);if ((
$receivedCommand eq $firstSendCommand)){shift (@sendCommandList);return (
(0x04cf+ 7992-0x2407));}else{Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x55\x6e\x65\x78\x70\x65\x63\x74\x65\x64\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x27"
.$command)."\x27\x2e\x20\x57\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x27").
$firstSendCommand)."\x27\x2e"));(my $secondSendCommand=__getCommandNameFromLine 
($sendCommandList[(0x102f+ 3019-0x1bf9)]));if (($receivedCommand eq 
$secondSendCommand)){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x27"
.$firstSendCommand).
"\x27\x20\x69\x73\x20\x6d\x69\x73\x73\x69\x6e\x67\x2e\x20\x50\x72\x6f\x63\x65\x65\x64\x20\x77\x69\x74\x68\x20\x73\x65\x63\x6f\x6e\x64\x20\x69\x6e\x20\x6c\x69\x6e\x65\x2e"
));shift (@sendCommandList);shift (@sendCommandList);return (
(0x09ac+ 7102-0x256a));}return ((0x081f+ 7422-0x251c));}}}elsif ((($command=~ /command=(.*),error=(\d+)/ )
or ($connected==(0x0157+ 4141-0x1184)))){if ((__handleRedisErrorIfPossible (
$response)==(0x040c+ 5897-0x1b14))){return ((0x19eb+ 1422-0x1f78));}return (
(0x0e77+ 3032-0x1a4f));}}sub commandMonitor{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x6d\x6f\x6e\x69\x74\x6f\x72\x20\x72\x65\x64\x69\x73\x2e"
);sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x6d\x6f\x6e\x69\x74\x6f\x72\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);(@sendCommandList=());while ((0x106c+ 2394-0x19c5)){(my (@ready)=$selector->
can_read ((0x0dc1+ 2626-0x0c4b)));foreach my $fh (@ready){if (($fh eq $readRedis
)){my ($read_buf);(my $bytes_read=main::nxread ($readRedis,(\$read_buf),32768));
if ((($bytes_read eq (0x0bc4+ 5048-0x1f7c))or ($bytes_read eq ("")))){
Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x53\x6f\x63\x6b\x65\x74\x20\x77\x61\x73\x20\x63\x6c\x6f\x73\x65\x64\x2e"
);$selector->remove ($readRedis);$selector->remove ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});main::nxclose ($readRedis);($readRedis=(""));(
$connected=(0x1358+ 2571-0x1d63));return ((""));}else{(my $response=$read_buf);
while ((($bytes_read==32768)or (not (($read_buf=~ /\n$/ ))))){($bytes_read=
main::nxread ($readRedis,(\$read_buf),32768));($response.=$read_buf);}
Logger::debug3 (((
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x4d\x6f\x6e\x69\x74\x6f\x72\x20\x72\x65\x74\x75\x72\x6e\x3a\x20"
.$response)."\x2e"));main::nxwrite (main::nxgetSTDOUT (),$response);}}}if (
NXShell::isExitRequestReceivedSIGINT ()){$selector->remove ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});$selector->remove ($readRedis);main::nxclose (
$readRedis);($readRedis=(""));($connected=(0x10c9+ 1782-0x17bf));return ((""));}
}}sub commandDebug{(my $param=shift (@_));(my (@params)=split ( / / ,$param,
(0x0f79+ 2951-0x1b00)));shift (@params);Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x3a\x20"
.join ($",@params))."\x2e"));(my $command=shift (@params));(my $key=shift (
@params));if (($command eq (""))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x43\x6f\x6d\x6d\x61\x6e\x64\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
);main::nxexit ((0x0af8+ 2834-0x160a));}(my $redisCommand=((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d".$command).
"\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62"));if (($key ne (""))){(
$redisCommand.=("\x2c\x6b\x65\x79\x3d".$key));}foreach my $field (@params){(
$redisCommand.=("\x2c\x66\x69\x65\x6c\x64\x3d".$field));}($redisCommand.="\x0a")
;sendToDb ($redisCommand);main::nxwrite (main::nxgetSTDOUT (),(get ()."\x0a"));}
sub commandInfo{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x69\x6e\x66\x6f\x20\x72\x65\x64\x69\x73\x2e"
);sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x69\x6e\x66\x6f\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);(@sendCommandList=());while ((my (@ready)=$selector->can_read (
(0x1c17+ 4700-0x22bb)))){foreach my $fh (@ready){if (($fh eq $readRedis)){my (
$read_buf);(my $bytes_read=main::nxread ($readRedis,(\$read_buf),32768));if (((
$bytes_read eq (0x0fcf+ 539-0x11ea))or ($bytes_read eq ("")))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x73\x6f\x63\x6b\x65\x74\x20\x77\x61\x73\x20\x63\x6c\x6f\x73\x65\x64\x2e"
);$selector->remove ($readRedis);$selector->remove ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});main::nxclose ($readRedis);($readRedis=(""));(
$connected=(0x0f2d+ 2462-0x18cb));return ((""));}else{(my $response=$read_buf);
while ((($bytes_read==32768)or (not (($read_buf=~ /\n$/ ))))){($bytes_read=
main::nxread ($readRedis,(\$read_buf),32768));($response.=$read_buf);}
Logger::debug3 (((
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x49\x6e\x66\x6f\x20\x72\x65\x74\x75\x72\x6e\x3a\x20"
.$response)."\x2e"));main::nxwrite (main::nxgetSTDOUT (),$response);closeDb ();
return;}}}}}sub commandScript{(my $param=shift (@_));(my (@params)=split ( / / ,
$param,(0x02ab+ 7725-0x20d8)));shift (@params);Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x73\x63\x72\x69\x70\x74\x3a\x20"
.join ($",@params))."\x2e"));(my $scriptName=shift (@params));if (($scriptName 
eq (""))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x53\x63\x72\x69\x70\x74\x20\x6e\x61\x6d\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
);main::nxexit ((0x0431+ 3812-0x1315));}main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x63\x72\x69\x70\x74");(my (@args)=());(my $returnValue
=NXRedisScript::executeScript ($scriptName,(\@args),(\@params)));if ((
$scriptName eq 
"\x67\x65\x74\x41\x6c\x6c\x44\x61\x74\x61\x46\x72\x6f\x6d\x53\x65\x74")){(
$returnValue=~ s/^"// );($returnValue=~ s/"$// );(my (@data)=split ( /" "/ ,
$returnValue,(0x00d5+ 8376-0x218d)));foreach my $singleData (@data){(my (%hash)=
split ( / / ,$singleData,(0x040f+ 4957-0x176c)));foreach my $key (keys (%hash)){
main::nxwrite (main::nxgetSTDOUT (),((($key."\x3a\x20").$hash{$key})."\x0a"));}
main::nxwrite (main::nxgetSTDOUT (),"\x0a");}}else{main::nxwrite (
main::nxgetSTDOUT (),$returnValue);}}sub checkFailCounter{(++$failCounter);if ((
$failCounter==(0x08bb+ 1199-0x0d69))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x61\x69\x6c\x65\x64\x20\x6f\x6e\x63\x65\x20\x63\x6f\x6e\x65\x6e\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x64\x62\x2e"
);}elsif (($failCounter==(0x1009+ 2869-0x1b3c))){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x61\x69\x6c\x65\x64\x20\x74\x77\x69\x63\x65\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x64\x62\x2e"
);}if (($failCounter>(0x0448+ 3115-0x1071))){if (($finalizeProcessStarted==
(0x0177+ 8360-0x221e))){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x61\x69\x6c\x65\x64\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x64\x62\x20"
.$failCounter).
"\x20\x74\x69\x6d\x65\x73\x2e\x20\x43\x6c\x6f\x73\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x73\x74\x61\x72\x74\x65\x64\x2e"
));}else{Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x61\x69\x6c\x65\x64\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x64\x62\x20"
.$failCounter).
"\x20\x74\x69\x6d\x65\x73\x2e\x20\x43\x6c\x6f\x73\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));main::nxexit ((0x10ea+ 5618-0x26dc));}}return;}sub forceCloseRedisClient{(
$connected=(0x087f+ 6446-0x21ac));closeDb ();}sub 
checkFailCounterAndCloseIfNeeded{if (($serverInit==(0x0e8a+ 1351-0x13d0))){
return;}if (($failCounter>(0x0a0c+ 4187-0x1a66))){shift (@sendCommandList);
forceCloseRedisClient ();}checkFailCounter ();}sub cleanCommandList{while ((
scalar (@sendCommandList)>(0x099c+ 5204-0x1df0))){get ();}}sub isSaveDone{(my $response
=shift (@_));if ((($response eq "\x4f\x4b")or ($response eq 
"\x42\x61\x63\x6b\x67\x72\x6f\x75\x6e\x64\x20\x73\x61\x76\x69\x6e\x67\x20\x73\x74\x61\x72\x74\x65\x64"
))){return ((0x04ed+ 1145-0x0965));}return ((0x210c+ 130-0x218e));}sub 
waitForAllCommands{while ((scalar (@sendCommandList)>(0x22f2+ 1003-0x26dd))){(my $command
=__getCommandNameFromLine ($sendCommandList[(0x04fc+ 8174-0x24ea)]));
Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x27"
.$command)."\x27\x2e"));get ();}}sub doNotCloseRedisThreadsOnExit{(
$doNotCloseRedisThreadsWhenFreePerl=(0x00c2+ 7328-0x1d61));}
NXMsg::register_error ("\x4e\x58\x52\x65\x64\x69\x73",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x74\x69\x6e\x75\x65\x4e\x78\x73\x65\x72\x76\x65\x72\x53\x68\x75\x74\x64\x6f\x77\x6e"
,(0x0a33+ 3469-0x15cc));"\x3f\x3f\x3f";
